local SPELLLIB_MAJOR, SPELLLIB_MINOR = "SpellLib-1.03", 1
local SpellLib = LibStub:NewLibrary(SPELLLIB_MAJOR, SPELLLIB_MINOR)

SpellLib.errorText = "|cffff0000ERROR:|"
SpellLib.classSpells = {}
SpellLib.classNames = {"DEATHKNIGHT", "DEMONHUNTER", "DRUID", "HUNTER", "MAGE", "MONK", "PALADIN", "PRIEST", "ROGUE", "SHAMAN", "WARLOCK", "WARRIOR", "ALL"}
SpellLib.specNames = {"BLOOD", "FROST", "UNHOLY", "HAVOC", "VENGEANCE", "BALANCE", "FERAL", "GUARDIAN", "RESTORATION", "MARKSMANSHIP", "BEASTMASTERY", "SURVIVAL", "FIRE", "ARCANE", "WINDWALKER", "MISTWEAVER", "BREWMASTER", "RETRIBUTION", "HOLY", "PROTECTION", "DISCIPLINE", "SHADOW","SUBTLETY", "ASSASSINATION", "OUTLAW", "ELEMENTAL", "ENHANCEMENT", "DESTRUCTION", "DEMONOLOGY", "AFFLICTION", "FURY", "ARMS", "BASIC", "COVENANT", "ALL"}
SpellLib.classSpecList = {
    ["DEATHKNIGHT"] = {"BLOOD", "FROST", "UNHOLY"},
    ["DEMONHUNTER"] = {"HAVOC", "VENGEANCE"},
    ["DRUID"] = {"BALANCE", "FERAL", "GUARDIAN", "RESTORATION"},
    ["HUNTER"] = {"BEASTMASTERY", "MARKSMANSHIP", "SURVIVAL"},
    ["MAGE"] = {"ARCANE", "FIRE", "FROST"},
    ["MONK"] = {"BREWMASTER", "MISTWEAVER", "WINDWALKER"},
    ["PALADIN"] = {"HOLY", "PROTECTION", "RETRIBUTION"},
    ["PRIEST"] = {"DISCIPLINE", "HOLY", "SHADOW"},
    ["ROGUE"] = {"ASSASSINATION", "OUTLAW", "SUBTLETY"},
    ["SHAMAN"] = {"ELEMENTAL", "ENHANCEMENT", "RESTORATION"},
    ["WARLOCK"] = {"AFFLICTION", "DEMONOLOG", "DESTRUCTION"},
    ["WARRIOR"] = {"ARMS", "FURY", "PROTECTION"}
}

function SpellLib:New()    
    self.classSpells = {
        DEATHKNIGHT = {
        	BASIC = {
        		{ name = "Anti-Magic Shell", id = 48707, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Anti-Magic Zone", id = 51052, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Chains of Ice", id = 45524, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Control Undead", id = 111673, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Dark Command", id = 56222, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Death's Advance", id = 48265, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Death's Advance", id = 343257, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Death Coil", id = 47541, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Death Gate", id = 50977, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Death Grip", id = 49576, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Death Strike", id = 49998, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Death and Decay", id = 43265, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Icebound Fortitude", id = 48792, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Lichborne", id = 49039, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Mind Freeze", id = 47528, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "On a Pale Horse", id = 51986, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Path of Frost", id = 3714, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Raise Ally", id = 61999, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Raise Dead", id = 46585, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Runeforging", id = 53428, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Sacrificial Pact", id = 327574, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Veteran of the Third War", id = 48263, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
            },
        	BLOOD = {
        		{ name = "Asphyxiate", id = 221562, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },        		
        		{ name = "Blood Boil", id = 50842, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Blood Boil", id = 316634, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Crimson Scourge", id = 81136, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Dancing Rune Weapon", id = 49028, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Death's Caress", id = 195292, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Death and Decay", id = 316664, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Gorefiend's Grasp", id = 108199, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Heart Strike", id = 206930, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Heart Strike", id = 316575, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
                { name = "Heart Strike", id = 317090, passive = false, rank = 3, requiresAura = false, requiredAuraID = nil },        		        		
        		{ name = "Marrowrend", id = 195182, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Marrowrend", id = 316746, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Mastery: Blood Shield", id = 77513, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Ossuary", id = 219786, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },        		
        		{ name = "Rune Tap", id = 194679, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Rune Tap", id = 316616, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },        		
        		{ name = "Vampiric Blood", id = 55233, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Vampiric Blood", id = 317133, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Veteran of the Third War", id = 316714, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
            },
        	FROST = {
        		{ name = "Dark Succor", id = 178819, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Death Strike", id = 278223, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },        		
        		{ name = "Empower Rune Weapon", id = 47568, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Empower Rune Weapon", id = 317230, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Frost Strike", id = 49143, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Frost Strike", id = 316803, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Frostwyrm's Fury", id = 279302, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Howling Blast", id = 49184, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Killing Machine", id = 51128, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Killing Machine", id = 317214, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Mastery: Frozen Heart", id = 77514, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Might of the Frozen Wastes", id = 81333, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Might of the Frozen Wastes", id = 343252, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Obliterate", id = 49020, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Obliterate", id = 317198, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },        		
        		{ name = "Pillar of Frost", id = 51271, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Pillar of Frost", id = 316849, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Remorseless Winter", id = 196770, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Remorseless Winter", id = 316794, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Rime", id = 59057, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Rime", id = 316838, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Runic Empowerment", id = 81229, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
            },
        	UNHOLY = {        		        		
        		{ name = "Apocalypse", id = 275699, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Apocalypse", id = 316961, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
                { name = "Apocalypse", id = 343755, passive = false, rank = 3, requiresAura = false, requiredAuraID = nil },
        		{ name = "Army of the Dead", id = 42650, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Dark Succor", id = 178819, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },        		
        		{ name = "Dark Transformation", id = 63560, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Dark Transformation", id = 325554, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Death Coil", id = 316941, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Death Strike", id = 278223, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Death and Decay", id = 316916, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Epidemic", id = 207317, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Festering Strike", id = 85948, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Festering Strike", id = 316867, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Mastery: Dreadblade", id = 77515, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Outbreak", id = 77575, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Raise Dead", id = 46584, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Runic Corruption", id = 51462, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },        		
        		{ name = "Scourge Strike", id = 55090, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Scourge Strike", id = 317234, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Sudden Doom", id = 49530, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
            },
        	COVENANT = {
        		{ name = "Shackle the Unworthy", id = 312940, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Abomination Limb", id = 340735, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Death's Due", id = 324128, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Swarming Mist", id = 337043, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil }
            },
        },
        DEMONHUNTER = {
        	BASIC = {
        		{ name = "Chaos Brand", id = 255260, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Chaos Strike", id = 344862, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },        		
        		{ name = "Consume Magic", id = 278326, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Consume Magic", id = 320313, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Demon's Bite", id = 344859, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Demonic Wards", id = 278386, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Disrupt", id = 183782, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Disrupt", id = 320361, passive = false, rank = 3, requiresAura = false, requiredAuraID = nil },
        		{ name = "Double Jump", id = 196055, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Fel Rush", id = 344865, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Glide", id = 131347, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },        		
        		{ name = "Immolation Aura", id = 258920, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Immolation Aura", id = 320364, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Imprison", id = 217832, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Shattered Souls", id = 178940, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Spectral Sight", id = 188501, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Spectral Sight", id = 320379, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },        		
        		{ name = "Throw Glaive", id = 185123, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Throw Glaive", id = 320386, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Torment", id = 185245, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
            },
        	HAVOC = {        		
        		{ name = "Blade Dance", id = 188499, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Blade Dance", id = 320402, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Blur", id = 198589, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Blur", id = 320407, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },        		
        		{ name = "Chaos Nova", id = 179057, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Chaos Nova", id = 320412, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Chaos Strike", id = 162794, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },        		
        		{ name = "Chaos Strike", id = 320413, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
                { name = "Chaos Strike", id = 343206, passive = false, rank = 3, requiresAura = false, requiredAuraID = nil },        		
        		{ name = "Darkness", id = 196718, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Darkness", id = 320420, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Demon's Bite", id = 162243, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Demonic Wards", id = 320383, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },        		
        		{ name = "Eye Beam", id = 198013, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Eye Beam", id = 320415, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Eye Beam", id = 343311, passive = false, rank = 3, requiresAura = false, requiredAuraID = nil },
        		{ name = "Fel Rush", id = 195072, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Fel Rush", id = 320416, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
                { name = "Fel Rush", id = 343017, passive = false, rank = 3, requiresAura = false, requiredAuraID = nil },
        		{ name = "Immolation Aura", id = 320377, passive = false, rank = 3, requiresAura = false, requiredAuraID = nil },        		
        		{ name = "Mastery: Demonic Presence", id = 185164, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Mastery: Demonic Presence", id = 320654, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },        		
        		{ name = "Metamorphosis", id = 320422, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
                { name = "Metamorphosis", id = 320421, passive = false, rank = 3, requiresAura = false, requiredAuraID = nil },
        		{ name = "Metamorphosis", id = 320645, passive = false, rank = 4, requiresAura = false, requiredAuraID = nil },
        		{ name = "Unrestrained Fury", id = 320770, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Unrestrained Fury", id = 343006, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Vengeful Retreat", id = 198793, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Vengeful Retreat", id = 320635, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
            },
        	VENGEANCE = {
        		{ name = "Chaos Brand", id = 281242, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Demon Spikes", id = 203720, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Demon Spikes", id = 321028, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Demonic Wards", id = 203513, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Demonic Wards", id = 320381, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
                { name = "Demonic Wards", id = 320382, passive = false, rank = 3, requiresAura = false, requiredAuraID = nil },        		
        		{ name = "Fel Devastation", id = 212084, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Fel Devastation", id = 320639, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Fiery Brand", id = 204021, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Fiery Brand", id = 320962, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
                { name = "Fiery Brand", id = 343010, passive = false, rank = 3, requiresAura = false, requiredAuraID = nil },
        		{ name = "Immolation Aura", id = 320378, passive = false, rank = 3, requiresAura = false, requiredAuraID = nil },
        		{ name = "Infernal Strike", id = 189110, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Infernal Strike", id = 320791, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
                { name = "Infernal Strike", id = 343016, passive = false, rank = 3, requiresAura = false, requiredAuraID = nil },
        		{ name = "Mastery: Fel Blood", id = 203747, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Mastery: Fel Blood", id = 321299, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Metamorphosis", id = 321067, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Metamorphosis", id = 321068, passive = false, rank = 3, requiresAura = false, requiredAuraID = nil },
        		{ name = "Revel in Pain", id = 343014, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Shattered Souls", id = 204254, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Shear", id = 203782, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Sigil of Flame", id = 204596, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Sigil of Flame", id = 320794, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Sigil of Misery", id = 207684, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Sigil of Misery", id = 320418, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },        		
        		{ name = "Sigil of Silence", id = 202137, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Sigil of Silence", id = 320417, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },        		
        		{ name = "Soul Cleave", id = 228477, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Soul Cleave", id = 343207, passive = false, rank = 3, requiresAura = false, requiredAuraID = nil },
                { name = "Soul Cleave", id = 321021, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Thick Skin", id = 320380, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Throw Glaive", id = 320387, passive = false, rank = 3, requiresAura = false, requiredAuraID = nil },
        		{ name = "Throw Glaive", id = 204157, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
            },
        	COVENANT = {
        		{ name = "Elysian Decree", id = 306830, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Fodder to the Flame", id = 329554, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "The Hunt", id = 323639, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Sinful Brand", id = 317009, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil }
            },
        },
        DRUID = {
        	BASIC = {
        		{ name = "Aquatic Form", id = 276012, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Barkskin", id = 22812, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Bear Form", id = 5487, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Cat Form", id = 768, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Cyclone", id = 33786, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Dash", id = 1850, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Dreamwalk", id = 193753, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },        		
        		{ name = "Entangling Roots", id = 339, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Entangling Roots", id = 343238, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Ferocious Bite", id = 22568, passive = false, rank = 1, requiresAura = true, requiredAuraID = {768} },
        		{ name = "Flight Form", id = 276029, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Growl", id = 6795, passive = false, rank = 1, requiresAura = true, requiredAuraID = {5487} },
        		{ name = "Heart of the Wild", id = 319454, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Hibernate", id = 2637, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Ironfur", id = 192081, passive = false, rank = 1, requiresAura = true, requiredAuraID = {5487} },
        		{ name = "Mangle", id = 33917, passive = false, rank = 1, requiresAura = true, requiredAuraID = {5487} },
        		{ name = "Moonfire", id = 8921, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Prowl", id = 5215, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Rebirth", id = 20484, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },        		
        		{ name = "Regrowth", id = 8936, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Regrowth", id = 231032, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Revive", id = 50769, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Shred", id = 5221, passive = false, rank = 1, requiresAura = true, requiredAuraID = {768} },
        		{ name = "Soothe", id = 2908, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Stampeding Roar", id = 106898, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Travel Form", id = 783, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Wrath", id = 5176, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
            },
        	BALANCE = {
        		{ name = "Astral Influence", id = 197524, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Celestial Alignment", id = 194223, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },        		
        		{ name = "Eclipse", id = 79577, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Eclipse", id = 328021, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Innervate", id = 29166, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Mastery: Total Eclipse", id = 326085, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Moonfire", id = 328023, passive = false, rank = 3, requiresAura = false, requiredAuraID = nil },        		
        		{ name = "Moonkin Form", id = 24858, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Moonkin Form", id = 231042, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Remove Corruption", id = 2782, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Shooting Stars", id = 202342, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Solar Beam", id = 78675, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },        		
        		{ name = "Starfall", id = 191034, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Starfall", id = 327541, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Starfire", id = 194153, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },        		
        		{ name = "Starsurge", id = 78674, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Starsurge", id = 328022, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },        		
        		{ name = "Sunfire", id = 93402, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Sunfire", id = 231050, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Typhoon", id = 132469, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Wrath", id = 190984, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
            },
        	FERAL = {
        		{ name = "Berserk", id = 106951, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Berserk", id = 343223, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Feline Adept", id = 300349, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Feline Swiftness", id = 131768, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Feral Instinct", id = 16949, passive = false, rank = 1, requiresAura = true, requiredAuraID = {768} },
        		{ name = "Infected Wounds", id = 48484, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Maim", id = 22570, passive = false, rank = 1, requiresAura = true, requiredAuraID = {768} },
        		{ name = "Mastery: Razor Claws", id = 77493, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Omen of Clarity", id = 16864, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Predatory Swiftness", id = 16974, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Primal Fury", id = 159286, passive = false, rank = 1, requiresAura = true, requiredAuraID = {768} },
        		{ name = "Rake", id = 1822, passive = false, rank = 1, requiresAura = true, requiredAuraID = {768} },
        		{ name = "Rake", id = 231052, passive = false, rank = 2, requiresAura = true, requiredAuraID = {768} },
        		{ name = "Remove Corruption", id = 2782, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Rip", id = 1079, passive = false, rank = 1, requiresAura = true, requiredAuraID = {768} },
        		{ name = "Shred", id = 231057, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },        		
        		{ name = "Shred", id = 231063, passive = false, rank = 3, requiresAura = false, requiredAuraID = nil },
                { name = "Shred", id = 343232, passive = false, rank = 4, requiresAura = false, requiredAuraID = nil },
        		{ name = "Skull Bash", id = 106839, passive = false, rank = 1, requiresAura = true, requiredAuraID = {768, 5487} },
        		{ name = "Survival Instincts", id = 61336, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Swipe", id = 213764, passive = false, rank = 1, requiresAura = true, requiredAuraID = {768, 5487} },
        		{ name = "Swipe", id = 231283, passive = false, rank = 2, requiresAura = true, requiredAuraID = {768, 5487} },
        		{ name = "Thrash", id = 106832, passive = false, rank = 1, requiresAura = true, requiredAuraID = {768, 5487} },
        		{ name = "Tiger's Fury", id = 5217, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Tiger's Fury", id = 231055, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
            },
        	GUARDIAN = {
        		{ name = "Bear Form", id = 270100, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Berserk", id = 50334, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Berserk", id = 343240, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },        		
        		{ name = "Frenzied Regeneration", id = 22842, passive = false, rank = 1, requiresAura = true, requiredAuraID = {5487} },
        		{ name = "Frenzied Regeneration", id = 273048, passive = false, rank = 2, requiresAura = true, requiredAuraID = {5487} },
                { name = "Frenzied Regeneration", id = 301768, passive = false, rank = 3, requiresAura = true, requiredAuraID = {5487} },
        		{ name = "Gore", id = 210706, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Incapacitating Roar", id = 99, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Infected Wounds", id = 345208, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Ironfur", id = 231070, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Lightning Reflexes", id = 231065, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Mangle", id = 231064, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Mastery: Nature's Guardian", id = 155783, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Maul", id = 6807, passive = false, rank = 1, requiresAura = true, requiredAuraID = {5487} },
        		{ name = "Remove Corruption", id = 2782, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Skull Bash", id = 106839, passive = false, rank = 1, requiresAura = true, requiredAuraID = {768, 5487} },
        		{ name = "Stampeding Roar", id = 288826, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Survival Instincts", id = 61336, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Survival Instincts", id = 328767, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Swipe", id = 213764, passive = false, rank = 1, requiresAura = true, requiredAuraID = {768, 5487} },
        		{ name = "Thick Hide", id = 16931, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Thrash", id = 106832, passive = false, rank = 1, requiresAura = true, requiredAuraID = {768, 5487} },
        		{ name = "Ursine Adept", id = 300346, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
            },
        	RESTORATION = {
        		{ name = "Efflorescence", id = 145205, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },        		
        		{ name = "Innervate", id = 29166, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Innervate", id = 326228, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },        		
        		{ name = "Ironbark", id = 102342, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Ironbark", id = 197061, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Lifebloom", id = 33763, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Mastery: Harmony", id = 77495, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Nature's Cure", id = 88423, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Nature's Swiftness", id = 132158, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Omen of Clarity", id = 113043, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Rejuvenation", id = 774, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Rejuvenation", id = 231040, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Revitalize", id = 212040, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },        		
        		{ name = "Sunfire", id = 93402, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Sunfire", id = 231050, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Swiftmend", id = 18562, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Tranquility", id = 740, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Ursol's Vortex", id = 102793, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Wild Growth", id = 48438, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Wild Growth", id = 328025, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Ysera's Gift", id = 145108, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
            },
        	COVENANT = {
        		{ name = "Kindred Spirits", id = 326434, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Adaptive Swarm", id = 325727, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Convoke the Spirits", id = 323764, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Ravenous Frenzy", id = 323546, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil }
            },
        },
        HUNTER = {
        	BASIC = {
        		{ name = "Arcane Shot", id = 185358, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Aspect of the Cheetah", id = 186257, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Aspect of the Cheetah", id = 343241, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Aspect of the Turtle", id = 186265, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Beast Lore", id = 1462, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Call Pet 2", id = 83242, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Call Pet 3", id = 83243, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Call Pet 4", id = 83244, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Call Pet 5", id = 83245, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Command Pet", id = 272651, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Disengage", id = 781, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Dismiss Pet", id = 2641, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Eagle Eye", id = 6197, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Exhilaration", id = 109304, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Eyes of the Beast", id = 321297, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Feed Pet", id = 6991, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Feign Death", id = 5384, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Flare", id = 1543, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Freezing Trap", id = 187650, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Hunter's Mark", id = 257284, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Improved Traps", id = 343247, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },        		
        		{ name = "Kill Shot", id = 53351, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Kill Shot", id = 343248, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Mend Pet", id = 136, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Mend Pet", id = 343242, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Misdirection", id = 34477, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Scare Beast", id = 1513, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Steady Shot", id = 56641, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Tame Beast", id = 1515, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Tar Trap", id = 187698, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },        		
        		{ name = "Tranquilizing Shot", id = 19801, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Tranquilizing Shot", id = 343244, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Wing Clip", id = 195645, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
            },
        	BEASTMASTERY = {
        		{ name = "Aspect of the Wild", id = 193530, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Barbed Shot", id = 217200, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Beast Cleave", id = 115939, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Bestial Wrath", id = 19574, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Bestial Wrath", id = 231548, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Cobra Shot", id = 193455, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Cobra Shot", id = 262838, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Concussive Shot", id = 5116, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Concussive Shot", id = 321023, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Counter Shot", id = 147362, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Exhilaration", id = 231546, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Exotic Beasts", id = 53270, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Intimidation", id = 19577, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Kill Command", id = 34026, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Kindred Spirits", id = 56315, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Mastery: Master of Beasts", id = 76657, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Multi-Shot", id = 2643, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Pack Tactics", id = 321014, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Wild Call", id = 185789, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
            },
        	MARKSMANSHIP = {
        		{ name = "Aimed Shot", id = 19434, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Arcane Shot", id = 321293, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Binding Shot", id = 109248, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Bursting Shot", id = 186387, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Concussive Shot", id = 321023, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Concussive Shot", id = 5116, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Counter Shot", id = 147362, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Exhilaration", id = 231546, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Lone Wolf", id = 155228, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Mastery: Sniper Training", id = 193468, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Multi-Shot", id = 257620, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Precise Shots", id = 260240, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Rapid Fire", id = 257044, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Rapid Fire", id = 321281, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Steady Shot", id = 321018, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Trick Shots", id = 257621, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "True Aim", id = 321287, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Trueshot", id = 288613, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
            },
        	SURVIVAL = {
        		{ name = "Aspect of the Eagle", id = 186289, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },        		
        		{ name = "Carve", id = 187708, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Carve", id = 294029, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Coordinated Assault", id = 266779, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Exhilaration", id = 231546, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Harpoon", id = 190925, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Harpoon", id = 231550, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Intimidation", id = 19577, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },        		
        		{ name = "Kill Command", id = 259489, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Kill Command", id = 263186, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Kill Shot", id = 320976, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Mastery: Spirit Bond", id = 263135, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Muzzle", id = 187707, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Raptor Strike", id = 186270, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Serpent Sting", id = 259491, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Wildfire Bomb", id = 259495, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Wildfire Bombs", id = 321290, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Wing Clip", id = 321026, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
            },
        	COVENANT = {
        		{ name = "Resonating Arrow", id = 308491, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Death Chakram", id = 325028, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Wild Spirits", id = 328231, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Flayed Shot", id = 324149, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil }
            },
        },
        MAGE = {
        	BASIC = {
        		{ name = "Arcane Explosion", id = 1449, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Arcane Intellect", id = 1459, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Blink", id = 1953, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Conjure Refreshment", id = 190336, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Counterspell", id = 2139, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Fire Blast", id = 319836, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Frost Nova", id = 122, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Frostbolt", id = 116, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Ice Block", id = 45438, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Invisibility", id = 66, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Mirror Image", id = 55342, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Polymorph", id = 118, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Portal", id = 343140, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Remove Curse", id = 475, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Slow Fall", id = 130, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Spellsteal", id = 30449, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Teleport", id = 343127, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Time Warp", id = 80353, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
            },
        	ARCANE = {
        		{ name = "Alter Time", id = 342245, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Arcane Barrage", id = 44425, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },        		
        		{ name = "Arcane Barrage", id = 231564, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
                { name = "Arcane Barrage", id = 321526, passive = false, rank = 3, requiresAura = false, requiredAuraID = nil },
        		{ name = "Arcane Blast", id = 30451, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Arcane Explosion", id = 321752, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Arcane Missiles", id = 5143, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Arcane Power", id = 12042, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Arcane Power", id = 343208, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Arcane Power", id = 321739, passive = false, rank = 3, requiresAura = false, requiredAuraID = nil },
        		{ name = "Clearcasting", id = 79684, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Clearcasting", id = 321758, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Clearcasting", id = 321420, passive = false, rank = 3, requiresAura = false, requiredAuraID = nil },        		
        		{ name = "Conjure Mana Gem", id = 759, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Evocation", id = 12051, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Evocation", id = 231565, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Greater Invisibility", id = 110959, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Mastery: Savant", id = 190740, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },        		
        		{ name = "Presence of Mind", id = 205025, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Presence of Mind", id = 321742, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Prismatic Barrier", id = 235450, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Prismatic Barrier", id = 321745, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },        		
        		{ name = "Slow", id = 31589, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Slow", id = 321747, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },        		
        		{ name = "Touch of the Magi", id = 321507, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Touch of the Magi", id = 343215, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
            },
        	FIRE = {
        		{ name = "Alter Time", id = 108978, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Blazing Barrier", id = 235313, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Blazing Barrier", id = 321708, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Cauterize", id = 86949, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },        		
        		{ name = "Combustion", id = 190319, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Combustion", id = 321710, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },        		
        		{ name = "Critical Mass", id = 117216, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Critical Mass", id = 231630, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },        		
        		{ name = "Dragon's Breath", id = 31661, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Dragon's Breath", id = 321707, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },        		        		
        		{ name = "Fire Blast", id = 231568, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
                { name = "Fire Blast", id = 108853, passive = false, rank = 3, requiresAura = false, requiredAuraID = nil },
                { name = "Fire Blast", id = 231567, passive = false, rank = 4, requiresAura = false, requiredAuraID = nil },
        		{ name = "Fireball", id = 133, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },        		
        		{ name = "Fireball", id = 157642, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
                { name = "Fireball", id = 343194, passive = false, rank = 3, requiresAura = false, requiredAuraID = nil },        		
        		{ name = "Flamestrike", id = 2120, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Flamestrike", id = 343230, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
                { name = "Flamestrike", id = 321709, passive = false, rank = 3, requiresAura = false, requiredAuraID = nil },
        		{ name = "Hot Streak", id = 195283, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Mastery: Ignite", id = 12846, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },        		
        		{ name = "Phoenix Flames", id = 257541, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Phoenix Flames", id = 343222, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Pyroblast", id = 11366, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Pyroblast", id = 321711, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Scorch", id = 2948, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
            },
        	FROST = {
        		{ name = "Alter Time", id = 108978, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },        		
        		{ name = "Blizzard", id = 190356, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Blizzard", id = 236662, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Blizzard", id = 321696, passive = false, rank = 3, requiresAura = false, requiredAuraID = nil },        		
        		{ name = "Brain Freeze", id = 190447, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Brain Freeze", id = 231584, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Cold Snap", id = 235219, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Cold Snap", id = 321699, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Cone of Cold", id = 120, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Cone of Cold", id = 343180, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Fingers of Frost", id = 112965, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Flurry", id = 44614, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Freeze", id = 231596, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Frost Nova", id = 343183, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Frostbolt", id = 343177, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Frozen Orb", id = 84714, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Ice Barrier", id = 11426, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Ice Lance", id = 30455, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Ice Lance", id = 343175, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Icy Veins", id = 12472, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Icy Veins", id = 321702, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Mastery: Icicles", id = 76613, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Mastery: Icicles", id = 321684, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },        		
        		{ name = "Shatter", id = 12982, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Shatter", id = 231582, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Summon Water Elemental", id = 31687, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
            },
        	COVENANT = {
        		{ name = "Radiant Spark", id = 307443, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Deathborne", id = 324220, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Shifting Power", id = 314791, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Mirrors of Torment", id = 314793, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil }
            },
        },
        MONK = {
        	BASIC = {
        		{ name = "Blackout Kick", id = 100784, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Crackling Jade Lightning", id = 117952, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Detox", id = 218164, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Expel Harm", id = 322101, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Fortifying Brew", id = 115203, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Leg Sweep", id = 119381, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Mystic Touch", id = 8647, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Paralysis", id = 115078, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Paralysis", id = 344359, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },        		
        		{ name = "Provoke", id = 115546, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Provoke", id = 328670, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Resuscitate", id = 115178, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },        		
        		{ name = "Roll", id = 109132, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Roll", id = 328669, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Spinning Crane Kick", id = 101546, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Tiger Palm", id = 100780, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },        		
        		{ name = "Touch of Death", id = 322109, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Touch of Death", id = 322113, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Transcendence", id = 101643, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Transcendence: Transfer", id = 119996, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Vivify", id = 116670, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Zen Pilgrimage", id = 126892, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
            },
        	BREWMASTER = {
        		{ name = "Blackout Kick", id = 205523, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Breath of Fire", id = 115181, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Brewmaster's Balance", id = 245013, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },        		
        		{ name = "Celestial Brew", id = 322507, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Celestial Brew", id = 322510, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Celestial Fortune", id = 216519, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Clash", id = 324312, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Expel Harm", id = 322102, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Fortifying Brew", id = 322960, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Gift of the Ox", id = 124502, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },        		
        		{ name = "Invoke Niuzao, the Black Ox", id = 132578, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Invoke Niuzao, the Black Ox", id = 322740, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Keg Smash", id = 121253, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Mastery: Elusive Brawler", id = 117906, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },        		
        		{ name = "Purifying Brew", id = 119582, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Purifying Brew", id = 343743, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Shuffle", id = 322120, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Spear Hand Strike", id = 116705, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Spinning Crane Kick", id = 322729, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Spinning Crane Kick", id = 322700, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Stagger", id = 322522, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Stagger", id = 115069, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Touch of Death", id = 325095, passive = false, rank = 3, requiresAura = false, requiredAuraID = nil },
        		{ name = "Vivify", id = 231602, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },        		
        		{ name = "Zen Meditation", id = 115176, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Zen Meditation", id = 328682, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
            },
        	MISTWEAVER = {
        		{ name = "Detox", id = 115450, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Enveloping Breath", id = 343655, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },        		
        		{ name = "Enveloping Mist", id = 124682, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Enveloping Mist", id = 231605, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Essence Font", id = 231633, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Essence Font", id = 191837, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },        		
        		{ name = "Expel Harm", id = 322104, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
                { name = "Expel Harm", id = 325214, passive = false, rank = 3, requiresAura = false, requiredAuraID = nil },
        		{ name = "Fortifying Brew", id = 325208, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Fortifying Brew", id = 243435, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Invoke Yu'lon, the Jade Serpent", id = 322118, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },        		
        		{ name = "Life Cocoon", id = 116849, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Life Coccoon", id = 343744, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Mastery: Gust of Mists", id = 117907, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Reawaken", id = 212051, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Renewing Mist", id = 115151, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Renewing Mist", id = 281231, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Revival", id = 115310, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },        		
        		{ name = "Rising Sun Kick", id = 107428, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Rising Sun Kick", id = 262840, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Soothing Mist", id = 115175, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Teachings of the Monastery", id = 116645, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Thunder Focus Tea", id = 116680, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Thunder Focus Tea", id = 231876, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Touch of Death", id = 344360, passive = false, rank = 3, requiresAura = false, requiredAuraID = nil },
        		{ name = "Vivify", id = 274586, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
            },
        	WINDWALKER = {        		
        		{ name = "Afterlife", id = 116092, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Afterlife", id = 322719, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Blackout Kick", id = 261917, passive = false, rank = 3, requiresAura = false, requiredAuraID = nil },
        		{ name = "Blackout Kick", id = 261916, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Disable", id = 116095, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Disable", id = 343731, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Expel Harm", id = 322106, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Fists of Fury", id = 113656, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Flying Serpent Kick", id = 101545, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Flying Serpent Kick", id = 344487, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Fortifying Brew", id = 243435, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Fortifying Brew", id = 325208, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },        		
        		{ name = "Invoke Xuen, the White Tiger", id = 123904, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Invoke Xuen, the White Tiger", id = 323999, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Mastery: Combo Strikes", id = 115636, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Rising Sun Kick", id = 107428, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Rising Sun Kick", id = 262840, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Spear Hand Strike", id = 116705, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Spinning Crane Kick", id = 343730, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Storm, Earth, and Fire", id = 137639, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Storm, Earth, and Fire", id = 231627, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Touch of Death", id = 325215, passive = false, rank = 3, requiresAura = false, requiredAuraID = nil },
        		{ name = "Touch of Karma", id = 122470, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Vivify", id = 231602, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Windwalking", id = 157411, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
            },
        	COVENANT = {
        		{ name = "Weapons of Order", id = 310454, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Bonedust Brew", id = 325216, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Faeline Stomp", id = 327104, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Fallen Order", id = 326860, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil }
            },
        },
        PALADIN = {
        	BASIC = {
        		{ name = "Avenging Wrath", id = 31884, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Avenging Wrath", id = 317872, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Blessing of Freedom", id = 1044, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Blessing of Protection", id = 1022, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Blessing of Sacrifice", id = 6940, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Blessing of Sacrifice", id = 200327, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Concentration Aura", id = 317920, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Consecration", id = 26573, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Crusader Aura", id = 32223, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Crusader Strike", id = 35395, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Devotion Aura", id = 465, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Divine Shield", id = 642, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Divine Steed", id = 190784, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Divine Steed", id = 317911, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Flash of Light", id = 19750, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Hammer of Justice", id = 853, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Hammer of Wrath", id = 24275, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Hammer of Wrath", id = 326730, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Hand of Reckoning", id = 62124, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Judgment", id = 20271, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Lay on Hands", id = 633, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Redemption", id = 7328, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },        		
        		{ name = "Retribution Aura", id = 183435, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Retribution Aura", id = 317906, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Sense Undead", id = 5502, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Shield of the Righteous", id = 53600, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Turn Evil", id = 10326, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Word of Glory", id = 85673, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
            },
        	HOLY = {
        		{ name = "Absolution", id = 212056, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Aura Mastery", id = 31821, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Avenging Wrath", id = 327979, passive = false, rank = 3, requiresAura = false, requiredAuraID = nil },
        		{ name = "Beacon of Light", id = 53563, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Beacon of Light", id = 231642, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Cleanse", id = 4987, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Crusader Strike", id = 231667, passive = false, rank = 3, requiresAura = false, requiredAuraID = nil },
        		{ name = "Divine Protection", id = 498, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Holy Light", id = 82326, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Holy Shock", id = 272906, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Holy Shock", id = 20473, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Infusion of Light", id = 53576, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Judgment", id = 275773, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Judgment", id = 231644, passive = false, rank = 3, requiresAura = false, requiredAuraID = nil },
        		{ name = "Light of Dawn", id = 85222, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Light of the Martyr", id = 183998, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Mastery: Lightbringer", id = 183997, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
            },
        	PROTECTION = {
        		{ name = "Ardent Defender", id = 31850, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },        		
        		{ name = "Avenger's Shield", id = 31935, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Avenger's Shield", id = 231665, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Cleanse Toxins", id = 213644, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Consecration", id = 344172, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Consecration", id = 327980, passive = false, rank = 3, requiresAura = false, requiredAuraID = nil },
        		{ name = "Crusader Strike", id = 342348, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Grand Crusader", id = 85043, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Guardian of Ancient Kings", id = 86659, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Hammer of the Righteous", id = 53595, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Hammer of the Righteous", id = 317854, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Judgment", id = 231663, passive = false, rank = 4, requiresAura = false, requiredAuraID = nil },
        		{ name = "Judgment", id = 275779, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Judgment", id = 315867, passive = false, rank = 3, requiresAura = false, requiredAuraID = nil },
        		{ name = "Mastery: Divine Bulwark", id = 76671, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Mastery: Divine Bulwark", id = 317907, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Rebuke", id = 96231, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Riposte", id = 161800, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Shining Light", id = 321136, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Word of Glory", id = 315921, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
            },
        	RETRIBUTION = {        		
        		{ name = "Art of War", id = 267344, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Art of War", id = 317912, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },        		
        		{ name = "Blade of Justice", id = 184575, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Blade of Justice", id = 327981, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Cleanse Toxins", id = 213644, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Crusader Strike", id = 35395, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Crusader Strike", id = 342348, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Crusader Strike", id = 231667, passive = false, rank = 3, requiresAura = false, requiredAuraID = nil },
        		{ name = "Divine Storm", id = 53385, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Hand of Hindrance", id = 183218, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Judgment", id = 231663, passive = false, rank = 4, requiresAura = false, requiredAuraID = nil },
        		{ name = "Judgment", id = 315867, passive = false, rank = 3, requiresAura = false, requiredAuraID = nil },
        		{ name = "Mastery: Hand of Light", id = 267316, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Rebuke", id = 96231, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Shield of Vengeance", id = 184662, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Templar's Verdict", id = 85256, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Wake of Ashes", id = 255937, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
            },
        	COVENANT = {
        		{ name = "Divine Toll", id = 304971, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Vanquisher's Hammer", id = 328204, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Blessing of the Seasons", id = 328278, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Ashen Hallow", id = 316958, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
            },
        },
        PRIEST = {
        	BASIC = {
        		{ name = "Desperate Prayer", id = 19236, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Dispel Magic", id = 528, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Fade", id = 586, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Focused Will", id = 45243, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Leap of Faith", id = 73325, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Levitate", id = 1706, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Mass Dispel", id = 32375, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Mind Blast", id = 8092, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Mind Control", id = 605, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Mind Soothe", id = 453, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Mind Vision", id = 2096, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Pain Suppression", id = 33206, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Power Infusion", id = 10060, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Power Word: Fortitude", id = 21562, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Power Word: Shield", id = 17, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Psychic Scream", id = 8122, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Resurrection", id = 2006, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Shackle Undead", id = 9484, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Shadow Word: Pain", id = 589, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Shadow Word: Death", id = 32379, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },        		
            },
        	DISCIPLINE = {
        		{ name = "Atonement", id = 81749, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Focused Will", id = 285485, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Holy Nova", id = 132157, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Holy Nova", id = 322112, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
                { name = "Mass Resurrection", id = 212036, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Mastery: Grace", id = 271534, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Mind Blast", id = 231682, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Mind Sear", id = 48045, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Pain Suppression", id = 33206, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Penance", id = 47540, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Power Word: Barrier", id = 62618, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },        		
        		{ name = "Power Word: Radiance", id = 194509, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Power Word: Radiance", id = 322115, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Power of the Dark Side", id = 198068, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Purify", id = 527, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Rapture", id = 47536, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Shadow Mend", id = 186263, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },        		
        		{ name = "Shadowfiend", id = 34433, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Shadowfiend", id = 343726, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Smite", id = 585, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Smite", id = 262861, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
            },
        	HOLY = {
        		{ name = "Divine Hymn", id = 64843, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Flash Heal", id = 2061, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Focused Will", id = 285485, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Guardian Spirit", id = 47788, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Heal", id = 2060, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Holy Fire", id = 14914, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Holy Nova", id = 132157, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Holy Nova", id = 322112, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Holy Word: Chastise", id = 88625, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Holy Word: Sanctify", id = 34861, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Holy Word: Serenity", id = 2050, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Holy Words", id = 63733, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Mass Resurrection", id = 212036, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Mastery: Echo of Light", id = 77485, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Prayer of Healing", id = 596, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Prayer of Mending", id = 33076, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Prayer of Mending", id = 319912, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Purify", id = 527, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Renew", id = 139, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Smite", id = 585, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Smite", id = 262861, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Spirit of Redemption", id = 20711, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Symbol of Hope", id = 64901, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
            },
        	SHADOW = {
        		{ name = "Dark Thoughts", id = 223802, passive = true, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Dispersion", id = 47585, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Mastery: Shadow Weaving", id = 343690, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Mind Flay", id = 15407, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Mind Sear", id = 32000, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Purify Disease", id = 213634, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Shadow Mend", id = 33325, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Shadowfiend", id = 34433, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Shadowfiend", id = 34433, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },        		
        		{ name = "Shadowform", id = 16592, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Shadowy Apparitions", id = 78203, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Silence", id = 6726, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Vampiric Embrace", id = 15286, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Vampiric Touch", id = 34914, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Void Bolt", id = 7588, passive = false, rank = 1, requiresAura = false, requiredAuraID = {194249} },
        		{ name = "Void Eruption", id = 207145, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Voidform", id = 126733, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil }                        		        		
            },
        	COVENANT = {
        		{ name = "Boon of the Ascended", id = 325013, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Unholy Nova", id = 324724, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Fae Guardians", id = 327661, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Mindgames", id = 323673, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil }
            },
        },
        ROGUE = {
        	BASIC = {
        		{ name = "Blind", id = 2094, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Cheap Shot", id = 1833, passive = false, rank = 1, requiresAura = true, requiredAuraID = {1784} },
        		{ name = "Cloak of Shadows", id = 31224, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Crimson Vial", id = 185311, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Crppling Poison", id = 3408, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Detection", id = 56814, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Distract", id = 1725, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Evasion", id = 5277, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Eviscerate", id = 196819, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Feint", id = 1966, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Fleet Footed", id = 31209, passive = true, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Kick", id = 1766, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Kidney Shot", id = 408, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Numbing Poison", id = 5761, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Pick Lock", id = 1804, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Pick Pocket", id = 921, passive = false, rank = 1, requiresAura = true, requiredAuraID = {1784} },
        		{ name = "Sap", id = 6770, passive = false, rank = 1, requiresAura = true, requiredAuraID = {1784} },
        		{ name = "Shiv", id = 5938, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Shroud of Concealment", id = 114018, passive = false, rank = 1, requiresAura = true, requiredAuraID = {1784} },
        		{ name = "Slice and Dice", id = 315496, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Sprint", id = 2983, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Stealth", id = 1784, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Tricks of the Trade", id = 57934, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Vanish", id = 1856, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Wound Poison", id = 8679, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
            },
        	ASSASSINATION = {
        		{ name = "Ambush", id = 8676, passive = false, rank = 1, requiresAura = true, requiredAuraID = {1784} },
        		{ name = "Deadly Poison", id = 2823, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Envenom", id = 32645, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Fan of Knives", id = 51723, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Garrote", id = 703, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Garrote", id = 231719, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Improved Poisons", id = 14117, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Improved Poisons", id = 330542, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },        		
        		{ name = "Mastery: Potent Assassin", id = 76803, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Mastery: Potent Assassin", id = 319473, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Mutilate", id = 1329, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Poisoned Knife", id = 185565, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Rupture", id = 1943, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Seal Fate", id = 14190, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Shadowstep", id = 36554, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Shiv", id = 319032, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Sinister Strike", id = 279877, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Slice and Dice", id = 344362, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Vendetta", id = 79140, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Venomous Wounds", id = 79134, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Wound Poison", id = 319066, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
            },
        	OUTLAW = {
        		{ name = "Adrenaline Rush", id = 13750, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Ambush", id = 8676, passive = false, rank = 1, requiresAura = true, requiredAuraID = {1784} },        		
        		{ name = "Between the Eyes", id = 315341, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Between the Eyes", id = 235484, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Blade Flurry", id = 13877, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Blade Flurry", id = 331851, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },        		
        		{ name = "Combat Potency", id = 61329, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Combat Potency", id = 35551, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Dispatch", id = 2098, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Evasion", id = 344363, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Gouge", id = 1776, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Grappling Hook", id = 195457, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Grappling Hook", id = 319600, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Instant Poison", id = 315584, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Mastery: Main Gauche", id = 76806, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Pistol Shot", id = 185763, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Restless Blades", id = 79096, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Roll the Bones", id = 315508, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Ruthlessness", id = 14161, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },        		
        		{ name = "Sinister Strike", id = 193315, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Sinister Strike", id = 279876, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
            },
        	SUBTLETY = {        		
        		{ name = "Backstab", id = 53, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Backstab", id = 319949, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Black Powder", id = 319175, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Black Powder", id = 319178, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Deepening Shadows", id = 185314, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },        		
        		{ name = "Eviscerate", id = 196819, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Eviscerate", id = 231716, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Find Weakness", id = 316219, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Instant Poison", id = 315584, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Mastery: Executioner", id = 76808, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Relentless Strikes", id = 58423, passive = true, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Rupture", id = 1943, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Shadow Blades", id = 121471, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Shadow Dance", id = 185313, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Shadow Techniques", id = 196912, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Shadowstep", id = 36554, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Shadowstrike", id = 185438, passive = false, rank = 1, requiresAura = true, requiredAuraID = {1784} },
        		{ name = "Shuriken Storm", id = 197835, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Shuriken Storm", id = 319951, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Shuriken Toss", id = 114014, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Sprint", id = 245751, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Symbols of Death", id = 212283, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Symbols of Death", id = 328077, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
            },
        	COVENANT = {
        		{ name = "Echoing Reprimand", id = 323547, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Serrated Bone Spike", id = 328547, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },                
        		{ name = "Sepsis", id = 328305, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Flagellation", id = 323654, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil }
            },
        },
        SHAMAN = {
        	BASIC = {
        		{ name = "Ancestral Spirit", id = 2008, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Astral Recall", id = 556, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Astral Shift", id = 108271, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Astral Shift", id = 343196, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Bloodlust", id = 2825, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Capacitor Totem", id = 192058, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Chain Heal", id = 1064, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Chain Lightning", id = 188443, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Earth Elemental", id = 198103, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Earthbind Totem", id = 2484, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Far Sight", id = 6196, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Flame Shock", id = 188389, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Flametongue Weapon", id = 318038, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Frost Shock", id = 196840, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Ghost Wolf", id = 2645, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Healing Stream Totem", id = 5394, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Healing Surge", id = 8004, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Hex", id = 51514, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Hex", id = 343198, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Improved Reincarnation", id = 319352, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Lightning Bolt", id = 188196, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Lightning Shield", id = 192106, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Primal Strike", id = 73899, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Purge", id = 370, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Reincarnation", id = 20608, passive = true, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Tremor Totem", id = 8143, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Water Walking", id = 546, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Wind Shear", id = 57994, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
            },
        	ELEMENTAL = {
        		{ name = "Chain Lightning", id = 231722, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Cleanse Spirit", id = 51886, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Earth Shock", id = 8042, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Earthquake", id = 61882, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },        		
        		{ name = "Elemental Fury", id = 60188, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Elemental Fury", id = 343190, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Fire Elemental", id = 198067, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Fire Elemental Totem", id = 343226, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },        		
        		{ name = "Lava Burst", id = 51505, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Lava Burst", id = 231721, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Lava Surge", id = 77756, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Mastery: Elemental Overload", id = 168534, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Primal Strike", id = 73899, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Spiritwalker's Grace", id = 79206, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Thunderstorm", id = 51490, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
            },
        	ENHANCEMENT = {
        		{ name = "Chain Lightning", id = 334308, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Cleanse Spirit", id = 51886, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Crash Lightning", id = 187874, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Feral Spirit", id = 51533, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },        		
        		{ name = "Lava Lash", id = 60103, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Lava Lash", id = 334033, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Maelstrom Weapon", id = 187880, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Mastery: Enhanced Elements", id = 77223, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Spirit Walk", id = 58875, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Stormbringer", id = 201845, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Stormbringer", id = 319930, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Stormstrike", id = 17364, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },        		
        		{ name = "Windfury Totem", id = 8512, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Windfury Totem", id = 343211, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Windfury Weapon", id = 33757, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
            },
        	RESTORATION = {
        		{ name = "Ancestral Vision", id = 212048, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Chain Heal", id = 231780, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Earth Shield", id = 974, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Healing Rain", id = 73920, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Healing Tide Totem", id = 108280, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Healing Tide Totem", id = 343205, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Healing Wave", id = 77472, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },        		
        		{ name = "Lava Burst", id = 51505, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Lava Burst", id = 231721, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Lava Surge", id = 77756, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },        		
        		{ name = "Mana Tide Totem", id = 16191, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Mana Tide Totem", id = 343182, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Mastery: Deep Healing", id = 77226, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Purify Spirit", id = 77130, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Resurgence", id = 16196, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Riptide", id = 61295, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Spirit Link Totem", id = 98008, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Spiritwalker's Grace", id = 79206, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },        		
        		{ name = "Tidal Waves", id = 51564, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Tidal Waves", id = 231785, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Water Shield", id = 52127, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
            },
        	COVENANT = {
        		{ name = "Vesper Totem", id = 324386, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Primordial Wave", id = 326059, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Fae Transfusion", id = 328923, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },        		
                { name = "Chain Harvest", id = 320674, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil }
            },
        },
        WARLOCK = {
        	BASIC = {
        		{ name = "Banish", id = 710, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Command Demon", id = 119898, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Corruption", id = 172, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Create Healthstone", id = 6201, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Create Soulwell", id = 29893, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Curse of Exhaustion", id = 334275, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Curse of Tongues", id = 1714, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Curse of Weakness", id = 702, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Demonic Circle", id = 48018, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Demonic Circle: Teleport", id = 48020, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Demonic Embrace", id = 288843, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Demonic Gateway", id = 111771, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Drain Life", id = 234153, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Eye of Kilrogg", id = 126, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },        		
        		{ name = "Fear", id = 5782, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Fear", id = 342914, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Fel Domination", id = 333889, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Health Funnel", id = 755, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Ritual of Doom", id = 342601, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Ritual of Summoning", id = 698, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Shadow Bolt", id = 686, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Shadowfury", id = 30283, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Soul Leech", id = 108370, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Soul Shards", id = 246985, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Soulstone", id = 20707, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Subjugate Demon", id = 1098, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Unending Breath", id = 5697, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Unending Resolve", id = 104773, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
            },
        	AFFLICTION = {
        		{ name = "Call Dreadstalkers", id = 104316, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Call Dreadstalkers", id = 334727, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Demonbolt", id = 264178, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Demonic Core", id = 267102, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Fel Firebolt", id = 334591, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Hand of Gul'dan", id = 105174, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Implosion", id = 196277, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Mastery: Master Demonologist", id = 77219, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Soul Link", id = 108415, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Soulstone", id = 231811, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Summon Demonic Tyrant", id = 265187, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Summon Demonic Tyrant", id = 334585, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
            },
        	DEMONOLOGY = {
        		{ name = "Call Dreadstalkers", id = 104316, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Call Dreadstalkers", id = 334727, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Demonbolt", id = 264178, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Demonic Core", id = 267102, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Fel Firebolt", id = 334591, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Hand of Gul'dan", id = 105174, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Implosion", id = 196277, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Mastery: Master Demonologist", id = 77219, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Soul Link", id = 108415, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Soulstone", id = 231811, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },        		
        		{ name = "Summon Demonic Tyrant", id = 265187, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Summon Demonic Tyrant", id = 334585, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
            },
        	DESTRUCTION = {
        		{ name = "Backdraft", id = 196406, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Chaos Bolt", id = 116858, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Conflagrate", id = 17962, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Conflagrate", id = 231793, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },        		
        		{ name = "Havoc", id = 80240, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Havoc", id = 335174, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Immolate", id = 348, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Incinerate", id = 29722, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Mastery: Chaotic Energies", id = 77220, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },        		
        		{ name = "Rain of Fire", id = 5740, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Rain of Fire", id = 335189, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Soulstone", id = 231811, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },        		
        		{ name = "Summon Infernal", id = 1122, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Summon Infernal", id = 335175, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
            },
        	COVENANT = {
        		{ name = "Scouring Tithe", id = 312321, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Decimating Bolt", id = 325289, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Soul Rot", id = 325640, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Impending Catastrophe", id = 321792, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil }
            },
        },
        WARRIOR = {
        	BASIC = {
        		{ name = "Battle Shout", id = 6673, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Berserker Rage", id = 18499, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Challenging Shout", id = 1161, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Charge", id = 100, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Hamstring", id = 1715, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Heroic Leap", id = 6544, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Heroic Throw", id = 57755, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Ignore Pain", id = 190456, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Intervene", id = 3411, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Intimidating Shout", id = 5246, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Pummel", id = 6552, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Rallying Cry", id = 97462, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Shattering Throw", id = 64382, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Shield Block", id = 2565, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Shield Slam", id = 23922, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Slam", id = 1464, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Spell Reflection", id = 23920, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Taunt", id = 355, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Victory Rush", id = 34428, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Whirlwind", id = 190411, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
            },
        	ARMS = {
        		{ name = "Bladestorm", id = 227847, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },        		
        		{ name = "Colossus Smash", id = 167105, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Colossus Smash", id = 316411, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },        		
        		{ name = "Die by the Sword", id = 118038, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Die by the Sword", id = 315948, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Execute", id = 316405, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Execute", id = 231830, passive = false, rank = 3, requiresAura = false, requiredAuraID = nil },
        		{ name = "Mastery: Deep Wounds", id = 262111, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },        		
        		{ name = "Mortal Strike", id = 12294, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Mortal Strike", id = 261900, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },        		
        		{ name = "Overpower", id = 7384, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Overpower", id = 316440, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
                { name = "Overpower", id = 316441, passive = false, rank = 3, requiresAura = false, requiredAuraID = nil },        		
        		{ name = "Piercing Howl", id = 12323, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Seasoned Soldier", id = 279423, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Slam", id = 261901, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
                { name = "Slam", id = 316534, passive = false, rank = 3, requiresAura = false, requiredAuraID = nil },        		
        		{ name = "Sweeping Strikes", id = 260708, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },        		
        		{ name = "Sweeping Strikes", id = 316432, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
                { name = "Sweeping Strikes", id = 316433, passive = false, rank = 3, requiresAura = false, requiredAuraID = nil },
        		{ name = "Tactician", id = 184783, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
            },
        	FURY = {
        		{ name = "Bloodthirst", id = 23881, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Bloodthirst", id = 316537, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Die by the Sword", id = 118038, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Enrage", id = 184361, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Enrage", id = 316424, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
                { name = "Enrage", id = 316425, passive = false, rank = 3, requiresAura = false, requiredAuraID = nil },        		
        		{ name = "Enraged Regeneration", id = 184364, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Enraged Regeneration", id = 316474, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Execute", id = 5308, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Execute", id = 316403, passive = false, rank = 3, requiresAura = false, requiredAuraID = nil },
        		{ name = "Execute", id = 316402, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Execute", id = 231827, passive = false, rank = 4, requiresAura = false, requiredAuraID = nil },
        		{ name = "Mastery: Unshackled Fury", id = 76856, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Piercing Howl", id = 12323, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Raging Blow", id = 85288, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Raging Blow", id = 316452, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Raging Blow", id = 316453, passive = false, rank = 3, requiresAura = false, requiredAuraID = nil },        		        		
        		{ name = "Rampage", id = 184367, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Rampage", id = 316412, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Rampage", id = 316519, passive = false, rank = 3, requiresAura = false, requiredAuraID = nil },
        		{ name = "Recklessness", id = 1719, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Recklessness", id = 316828, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Single-Minded Fury", id = 81099, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Titan's Grip", id = 46917, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Whirlwind", id = 12950, passive = false, rank = 3, requiresAura = false, requiredAuraID = nil },
        		{ name = "Whirlwind", id = 190411, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Whirlwind", id = 316435, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
            },
        	PROTECTION = {
        		{ name = "Avatar", id = 107574, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Avatar", id = 316438, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Deep Wounds", id = 115768, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },        		
        		{ name = "Demoralizing Shout", id = 1160, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Demoralizing Shout", id = 316464, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Devastate", id = 20243, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Execute", id = 316405, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Execute", id = 231830, passive = false, rank = 3, requiresAura = false, requiredAuraID = nil },
        		{ name = "Ignore Pain", id = 316778, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Last Stand", id = 12975, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Mastery: Critical Block", id = 76857, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Revenge", id = 6572, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Riposte", id = 161798, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Shield Slam", id = 231834, passive = false, rank = 3, requiresAura = false, requiredAuraID = nil },
        		{ name = "Shield Slam", id = 316523, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Shield Slam", id = 316790, passive = false, rank = 4, requiresAura = false, requiredAuraID = nil },
        		{ name = "Shield Wall", id = 871, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Shield Wall", id = 316834, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Shockwave", id = 46968, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Thunder Clap", id = 6343, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Thunder Clap", id = 316414, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        		{ name = "Vanguard", id = 71, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Vanguard", id = 316428, passive = false, rank = 2, requiresAura = false, requiredAuraID = nil },
        	},
        	COVENANT = {
        		{ name = "Spear of Bastion", id = 307865, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Conqueror's Banner", id = 324143, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Ancient Aftershock", id = 325886, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Condemn", id = 317349, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        	},
        },
        COVENANT = {
        	GENERAL = {
        		{ name = "Summon Steward", id = 324739, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Fleshcraft", id = 324631, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        		{ name = "Soulshape", id = 310143, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
                { name = "Door of Shadows", id = 340570, passive = false, rank = 1, requiresAura = false, requiredAuraID = nil },
        	},
        } 
    }
    
    self.talents = {
        DEATHKNIGHT = {
        	BLOOD = {
        		{ name = "Heartbreaker", id = 221536, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Blooddrinker", id = 206931, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Tombstone", id = 219809, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Rapid Decomposition", id = 194662, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Hemostasis", id = 273946, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Consumption", id = 274156, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Foul Bulwark", id = 206974, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Relish in Blood", id = 317610, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Blood Tap", id = 221699, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Will of the Necropolis", id = 206967, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Anti-Magic Barrier", id = 205727, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Mark of Blood", id = 206940, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Grip of the Dead", id = 273952, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Tightening Grasp", id = 206970, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Wraith Walk", id = 212552, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Voracious", id = 273953, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Death Pact", id = 48743, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Bloodworms", id = 195679, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Purgatory", id = 114556, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Red Thirst", id = 205723, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Bonestorm", id = 194844, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
            },
        	FROST = {
        		{ name = "Inexorable Assault", id = 253593, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Icy Talons", id = 194878, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Cold Heart", id = 281208, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Runic Attenuation", id = 207104, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Murderous Efficiency", id = 207061, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Horn of Winter", id = 57330, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Death's Reach", id = 276079, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Asphyxiate", id = 108194, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Blinding Sleet", id = 207167, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Avalanche", id = 207142, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Frozen Pulse", id = 194909, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Frostscythe", id = 207230, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Permafrost", id = 207200, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Wraith Walk", id = 212552, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Death Pact", id = 48743, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Gathering Storm", id = 194912, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Hypothermic Presence", id = 321995, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Glacial Advance", id = 194913, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Icecap", id = 207126, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Obliteration", id = 281238, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Breath of Sindragosa", id = 152279, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
            },
        	UNHOLY = {
        		{ name = "Infected Claws", id = 207272, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "All Will Serve", id = 194916, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Clawing Shadows", id = 207311, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = true, replacesSpell = 55090 },
        		{ name = "Bursting Sores", id = 207264, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Ebon Fever", id = 207269, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Unholy Blight", id = 115989, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Grip of the Dead", id = 273952, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Death's Reach", id = 276079, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Asphyxiate", id = 108194, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Pestilent Pustules", id = 194917, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Harbinger of Doom", id = 276023, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Soul Reaper", id = 343294, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Spell Eater", id = 207321, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Wraith Walk", id = 212552, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Death Pact", id = 48743, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Pestilence", id = 277234, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Unholy Pact", id = 319230, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Defile", id = 152280, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = true, replacesSpell = 43265 },
        		{ name = "Army of the Damned", id = 276837, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Summon Gargoyle", id = 49206, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Unholy Assault", id = 207289, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
            },
        },
        DEMONHUNTER = {
        	HAVOC = {
        		{ name = "Blind Fury", id = 203550, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Demonic Appetite", id = 206478, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Felblade", id = 232893, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Insatiable Hunger", id = 258876, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Burning Hatred", id = 320374, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Demon Blades", id = 203555, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = true, replacesSpell = 344859 },
        		{ name = "Trail of Ruin", id = 258881, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Unbound Chaos", id = 347461, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Glaive Tempest", id = 342817, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Sould Rendering", id = 204909, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Desperate Instincts", id = 205411, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Netherwalk", id = 196555, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Cycle of Hatred", id = 258887, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "First Blood", id = 206416, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Essence Break", id = 258860, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Unleashed Power", id = 206477, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Master of the Glaive", id = 203556, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Fel Eruption", id = 211881, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Demonic", id = 213410, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Momentum", id = 206476, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Fel Barrage", id = 258925, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
            },
        	VENGEANCE = {
        		{ name = "Abyssal Strike", id = 207550, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Agonizing Flames", id = 207548, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Felblade", id = 232893, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Feast of Souls", id = 207697, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Fallout", id = 227174, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Burning Alive", id = 207739, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Infernal Armor", id = 320331, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Charred Flesh", id = 336639, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Spirit Bomb", id = 247454, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Soul Rending", id = 217996, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Feed the Demon", id = 218612, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Fracture", id = 263642, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = true, replacesSpell = 203782 },
        		{ name = "Concentrated Sigils", id = 207666, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Quickened Sigils", id = 209281, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Sigil of Chains", id = 202138, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Void Reaver", id = 268175, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Demonic", id = 321453, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Soul Barrier", id = 263648, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Last Resort", id = 209258, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Ruinous Bulwark", id = 326853, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Bulk Extraction", id = 320341, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
            },
        },
        DRUID = {
        	BALANCE = {
        		{ name = "Nature's Balance", id = 202430, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Warrior of Elune", id = 202425, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Force of Nature", id = 205636, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Tiger Dash", id = 252216, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = true, replacesSpell = 1850 },
        		{ name = "Renewal", id = 108238, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Wild Charge", id = 132302, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Feral Affinity", id = 202157, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Guardian Affinity", id = 197491, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Restoration Affinity", id = 197492, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Mighty Bash", id = 5211, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Mass Entanglement", id = 102359, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Heart of the Wild", id = 319454, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Soul of the Forest", id = 114107, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Starlord", id = 202345, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Incarnation: Chosen of Elune", id = 102560, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = true, replacesSpell = 194223 },
        		{ name = "Stellar Drift", id = 202354, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Twin Moons", id = 279620, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Stellar Flare", id = 202347, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Solstice", id = 343647, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
                { name = "Fury of Elune", id = 202770, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },        		
                { name = "New Moon", id = 274281, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },        		
            },
        	FERAL = {
        		{ name = "Predator", id = 202021, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Sabertooth", id = 202031, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Lunar Inspiration", id = 155580, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Tiger Dash", id = 252216, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = true, replacesSpell = 1850 },
        		{ name = "Renewal", id = 108238, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Wild Charge", id = 132302, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Balance Affinity", id = 197488, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Guardian Affinity", id = 217615, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Restoration Affinity", id = 197492, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Mighty Bash", id = 5211, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Mass Entanglement", id = 102359, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Heart of the Wild", id = 319454, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Soul of the Forest", id = 158476, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Savage Roar", id = 52610, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Incarnation: King of the Jungle", id = 102543, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = true, replacesSpell = 106951 },
        		{ name = "Scent of Blood", id = 285564, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Brutal Slash", id = 202028, requiresAura = false, requiredAuraID = {768} , passive = false, isReplacement = true, replacesSpell = 213764 },
        		{ name = "Primal Wrath", id = 285381, requiresAura = false, requiredAuraID = {768} , passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Moment of Clarity", id = 236068, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Bloodtalons", id = 319439, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Feral Frenzy", id = 274837, requiresAura = false, requiredAuraID = {768} , passive = false, isReplacement = false, replacesSpell = nil },
            },
        	GUARDIAN = {
        		{ name = "Brambles", id = 203953, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Blood Frenzy", id = 203962, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Bristling Fur", id = 155835, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Tiger Dash", id = 252216, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = true, replacesSpell = 1850 },
        		{ name = "Renewal", id = 108238, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Wild Charge", id = 132302, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Balance Affinity", id = 197488, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Feral Affinity", id = 202155, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Restoration Affinity", id = 197492, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Mighty Bash", id = 5211, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Mass Entanglement", id = 102359, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Heart of the Wild", id = 319454, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Soul of the Forest", id = 158477, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Galactic Guardian", id = 203964, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Incarnation: Guardian of Ursoc", id = 102558, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = true, replacesSpell = 106951 },
        		{ name = "Earthwarden", id = 203974, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Survival of the Fittest", id = 203965, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Guardian of Elune", id = 155578, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Rend and Tear", id = 204053, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Tooth and Claw", id = 135288, requiresAura = false, requiredAuraID = {5487} , passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Pulverize", id = 80313, requiresAura = false, requiredAuraID = {5487} , passive = false, isReplacement = false, replacesSpell = nil },
            },
        	RESTORATION = {
        		{ name = "Abundance", id = 207383, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Nourish", id = 50464, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Cenarion Ward", id = 102351, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Tiger Dash", id = 252216, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = true, replacesSpell = 1850 },
        		{ name = "Renewal", id = 108238, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Wild Charge", id = 132302, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Balance Affinity", id = 197632, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Feral Affinity", id = 197490, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Guardian Affinity", id = 197491, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Mighty Bash", id = 5211, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Mass Entanglement", id = 102359, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Heart of the Wild", id = 319454, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Soul of the Forest", id = 158478, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Cultivation", id = 200390, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Incarnation: Tree of Life", id = 33891, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Inner Peace", id = 197073, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Spring Blossoms", id = 207385, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Overgrowth", id = 203651, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Photosynthesis", id = 274902, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Germination", id = 155675, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Flourish", id = 197721, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
            },
        },
        HUNTER = {
        	BEASTMASTERY = {
        		{ name = "Killer Instinct", id = 273887, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Animal Companion", id = 267116, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Dire Beast", id = 120679, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Scent of Blood", id = 193532, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "One with the Pack", id = 199528, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Chimaera Shot", id = 53209, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Trailblazer", id = 199921, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Natural Mending", id = 270581, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Camouflage", id = 199483, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Spitting Cobra", id = 257891, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Thrill of the Hunt", id = 257944, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "A Murder of Crows", id = 131894, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Born To Be Wild", id = 266921, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Posthaste", id = 109215, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Binding Shot", id = 109248, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Stomp", id = 199530, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Barrage", id = 120360, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Stampede", id = 201430, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Aspect of the Beast", id = 191384, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Killer Cobra", id = 199532, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Bloodshed", id = 321530, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
            },
        	MARKSMANSHIP = {
        		{ name = "Master Marksman", id = 260309, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Serpent Sting", id = 271788, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "A Murder of Crows", id = 131894, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Careful Aim", id = 260228, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Barrage", id = 120360, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Explosive Shot", id = 212431, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Trailblazer", id = 199921, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Natural Mending", id = 270581, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Camouflage", id = 199483, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Steady Focus", id = 193533, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Streamline", id = 260367, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Chimaera Shot", id = 342049, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Born To Be Wild", id = 266921, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Posthaste", id = 109215, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Binding Shackles", id = 321468, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Lethal Shots", id = 260393, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Dead Eye", id = 321460, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Double Tap", id = 260402, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Calling the Shots", id = 260404, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Lock and Load", id = 194595, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Volley", id = 260243, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
            },
        	SURVIVAL = {
        		{ name = "Viper's Venom", id = 268501, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Terms of Engagement", id = 265895, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Alpha Predator", id = 269737, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Guerrilla Tactics", id = 264332, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Hydra's Bite", id = 260241, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Butchery", id = 212436, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = true, replacesSpell = 187708 },
        		{ name = "Trailblazer", id = 199921, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Natural Mending", id = 270581, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Camouflage", id = 199483, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Bloodseeker", id = 260248, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Steel Trap", id = 162488, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "A Murder of Crows", id = 131894, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Born To Be Wild", id = 266921, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Posthaste", id = 109215, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Binding Shot", id = 109248, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Tip of the Spear", id = 260285, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Mongoose Bite", id = 259387, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Flanking Strike", id = 269751, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Birds of Prey", id = 260331, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Wildfire Infusion", id = 271014, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Chakrams", id = 259391, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
            },
        },
        MAGE = {
        	ARCANE = {
        		{ name = "Amplification", id = 236628, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Rule of Threes", id = 264354, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Arcane Familiar", id = 205022, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Master of Time", id = 342249, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Shimmer", id = 212653, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Slipstream", id = 236457, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Incanter's Flow", id = 1463, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Focus Magic", id = 321358, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Rune of Power", id = 116011, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Resonance", id = 205028, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Arcane Echo", id = 342231, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Nether Tempest", id = 114923, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Chrono Shift", id = 235711, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Ice Ward", id = 205036, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Ring of Frost", id = 113724, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Reverberate", id = 281482, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Arcane Orb", id = 153626, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Supernova", id = 157980, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Overpowered", id = 155147, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Time Anomaly", id = 210805, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Enlightened", id = 321387, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
            },
        	FIRE = {
        		{ name = "Firestarter", id = 205026, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Pyromaniac", id = 205020, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Searing Touch", id = 269644, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Blazing Soul", id = 235365, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Shimmer", id = 212653, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Blast Wave", id = 157981, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Incanter's Flow", id = 1463, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Focus Magic", id = 321358, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Rune of Power", id = 116011, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Flame On", id = 205029, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Alexstrasza's Fury", id = 235870, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "From the Ashes", id = 342344, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Frenetic Speed", id = 236058, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Ice Ward", id = 205036, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Ring of Frost", id = 113724, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Flame Patch", id = 205037, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Conflagration", id = 205023, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Living Bomb", id = 44457, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Kindling", id = 155148, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Pyroclasm", id = 269650, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Meteor", id = 153561, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
            },
        	FROST = {
        		{ name = "Bone Chilling", id = 205027, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Lonely Winter", id = 205024, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = true, replacesSpell = 31687 },
        		{ name = "Ice Nova", id = 157997, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Glacial Insulation", id = 235297, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Shimmer", id = 212653, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Ice Floes", id = 108839, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Incanter's Flow", id = 1463, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Focus Magic", id = 321358, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Rune of Power", id = 116011, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Frozen Touch", id = 205030, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Chain Reaction", id = 278309, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Ebonbolt", id = 257537, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Frigid Winds", id = 235224, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Ice Ward", id = 205036, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Ring of Frost", id = 113724, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Freezing Rain", id = 270233, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Splitting Ice", id = 56377, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Comet Storm", id = 153595, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Thermal Void", id = 155149, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Ray of Frost", id = 205021, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Glacial Spike", id = 199786, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
            },
        },
        MONK = {
        	BREWMASTER = {
        		{ name = "Eye of the Tiger", id = 196607, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Chi Wave", id = 115098, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Chi Burst", id = 123986, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Celerity", id = 115173, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Chi Torpedo", id = 115008, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Tiger's Lust", id = 116841, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Light Brewing", id = 325093, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Spitfire", id = 242580, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Black Ox Brew", id = 115399, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Tiger Tail Sweep", id = 264348, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Summon Black Ox Statue", id = 115315, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Ring of Peace", id = 116844, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Bob and Weave", id = 280515, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Healing Elixir", id = 122281, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Dampen Harm", id = 122278, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Special Delivery", id = 196730, requiresAura = false, requiredAuraID = nil, passive = false1, isReplacement = false, replacesSpell = nil },
        		{ name = "Rushing Jade Wind", id = 116847, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Exploding Keg", id = 325153, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "High Tolerance", id = 196737, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Celestial Flames", id = 325177, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Blackout Combo", id = 196736, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
            },
        	MISTWEAVER = {
        		{ name = "Mist Wrap", id = 197900, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Chi Wave", id = 115098, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Chi Burst", id = 123986, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Celerity", id = 115173, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Chi Torpedo", id = 115008, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Tiger's Lust", id = 116841, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Lifecycles", id = 197915, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Spirit of the Crane", id = 210802, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Mana Tea", id = 197908, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Tiger Tail Sweep", id = 264348, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Song of Chi-Ji", id = 198898, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Ring of Peace", id = 116844, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Healing Elixir", id = 122281, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Diffuse Magic", id = 122783, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Dampen Harm", id = 122278, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Summon Jade Serpent Statue", id = 115313, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Refreshing Jade Wind", id = 196725, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Invoke Chi-Ji, the Red Crane", id = 325197, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = true, replacesSpell = 322118 },
        		{ name = "Focused Thunder", id = 197895, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Upwelling", id = 274963, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Rising Mist", id = 274909, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
            },
        	WINDWALKER = {
        		{ name = "Eye of the Tiger", id = 196607, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Chi Wave", id = 115098, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Chi Burst", id = 123986, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Celerity", id = 115173, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Chi Torpedo", id = 115008, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Tiger's Lust", id = 116841, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Ascension", id = 115396, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Fist of the White Tiger", id = 261947, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Energizing Elixir", id = 115288, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Tiger Tail Sweep", id = 264348, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Good Karma", id = 280195, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Ring of Peace", id = 116844, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Inner Strength", id = 261767, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Diffuse Magic", id = 122783, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Dampen Harm", id = 122278, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Hit Combo", id = 196740, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Rushing Jade Wind", id = 116847, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Dance of Chi-Ji", id = 325201, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Spiritual Focus", id = 280197, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Whirling Dragon Punch", id = 152175, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Serenity", id = 152173, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = true, replacesSpell = 137639 },
            },
        },
        PALADIN = {
        	HOLY = {
        		{ name = "Crusader's Might", id = 196926, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Bestow Faith", id = 223306, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Light's Hammer", id = 114158, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Saved by the Light", id = 157047, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Judgment of Light", id = 183778, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Holy Prism", id = 114165, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Fist of Justice", id = 234299, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Repentance", id = 20066, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Blinding Light", id = 115750, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Unbreakable Spirit", id = 114154, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Cavalier", id = 230332, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Rule of Law", id = 214202, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Divine Purpose", id = 223817, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Holy Avenger", id = 105809, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Seraphim", id = 152262, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Sanctified Wrath", id = 53376, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Avenging Crusader", id = 216331, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = true, replacesSpell = 31884 },
        		{ name = "Awakening", id = 248033, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Glimmer of Light", id = 325966, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Beacon of Faith", id = 156910, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Beacon of Virtue", id = 200025, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = true, replacesSpell = 53563 },
            },
        	PROTECTION = {
        		{ name = "Holy Shield", id = 152261, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Redoubt", id = 280373, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Blessed Hammer", id = 204019, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = true, replacesSpell = 53595 },
        		{ name = "First Avenger", id = 203776, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Crusader's Judgment", id = 204023, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Moment of Glory", id = 327193, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Fist of Justice", id = 234299, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Repentance", id = 20066, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Blinding Light", id = 115750, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Unbreakable Spirit", id = 114154, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Cavalier", id = 230332, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Blessing of Spellwarding", id = 204018, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = true, replacesSpell = 1022 },
        		{ name = "Divine Purpose", id = 223817, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Holy Avenger", id = 105809, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Seraphim", id = 152262, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },        		
        		{ name = "Hand of the Protector", id = 315924, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Consecrated Ground", id = 204054, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Judgment of Light", id = 183778, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Sanctified Wrath", id = 171648, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
                { name = "Righteous Protector", id = 204074, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Final Stand", id = 204077, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
            },
        	RETRIBUTION = {
        		{ name = "Zeal", id = 269569, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Righteous Verdict", id = 267610, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Execution Sentence", id = 343527, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Fires of Justice", id = 203316, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Blade of Wrath", id = 231832, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Empyrean Power", id = 326732, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Fist of Justice", id = 234299, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Repentance", id = 20066, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Blinding Light", id = 115750, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Unbreakable Spirit", id = 114154, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Cavalier", id = 230332, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Eye for an Eye", id = 205191, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Divine Purpose", id = 223817, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Holy Avenger", id = 105809, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Seraphim", id = 152262, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Selfless Healer", id = 85804, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Justicar's Vengeance", id = 215661, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Healing Hands", id = 326734, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Sanctified Wrath", id = 317866, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Crusade", id = 231895, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = true, replacesSpell = 31884 },
        		{ name = "Final Reckoning", id = 343721, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
            },
        },
        PRIEST = {
        	DISCIPLINE = {
        		{ name = "Castigation", id = 193134, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Twist of Fate", id = 265259, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Schism", id = 214621, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Body and Soul", id = 64129, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Masochism", id = 193063, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Angelic Feather", id = 121536, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Shield Discipline", id = 197045, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Mindbender", id = 123040, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = true, replacesSpell = 34433 },
        		{ name = "Power Word: Solace", id = 129250, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Psychic Voice", id = 196704, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Dominant Mind", id = 205367, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Shining Force", id = 204263, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Sins of the Many", id = 280391, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Contrition", id = 197419, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Shadow Covenant", id = 314867, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Purge the Wicked", id = 204197, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = true, replacesSpell = 589 },
        		{ name = "Divine Star", id = 110744, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Halo", id = 120517, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Lenience", id = 238063, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Spirit Shell", id = 109964, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = true, replacesSpell = 47536 },
        		{ name = "Evangelism", id = 246287, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
            },
        	HOLY = {
        		{ name = "Enlightenment", id = 193155, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Trail of Light", id = 200128, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Renewed Faith", id = 341997, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Angel's Mercy", id = 238100, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Body and Soul", id = 64129, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Angelic Feather", id = 121536, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Cosmic Ripple", id = 238136, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Guardian Angel", id = 200209, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Afterlife", id = 196707, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Psychic Voice", id = 196704, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Censure", id = 200199, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Shining Force", id = 204263, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Surge of Light", id = 109186, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Binding Heal", id = 32546, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Prayer Circle", id = 321377, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Benediction", id = 193157, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Divine Star", id = 110744, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Halo", id = 120517, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Light of the Naaru", id = 196985, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Apotheosis", id = 200183, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Holy Word: Salvation", id = 265202, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
            },
        	SHADOW = {
        		{ name = "Fortress of the Mind", id = 193195, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Death and Madness", id = 321291, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Unfurling Darkness", id = 341273, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Body and Soul", id = 64129, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "San'layn", id = 199855, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Intangibility", id = 288733, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Twist of Fate", id = 109142, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Misery", id = 238558, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Searing Nightmare", id = 341385, requiresAura = false, requiredAuraID = {194249} , passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Last Word", id = 263716, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Mind Bomb", id = 205369, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = true, replacesSpell = 8122 },
        		{ name = "Psychic Horror", id = 64044, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Auspicious Spirits", id = 155271, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Psychic Link", id = 199484, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Shadow Crash", id = 205385, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Damnation", id = 341374, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Mindbender", id = 200174, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = true, replacesSpell = 34433 },
        		{ name = "Void Torrent", id = 263165, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Ancient Madness", id = 341240, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Hungering Void", id = 345218, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Surrender to Madness", id = 319952, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
            },
        },
        ROGUE = {
        	ASSASSINATION = {
        		{ name = "Master Poisoner", id = 196864, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
                { name = "Elaborate Planning", id = 193640, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
                { name = "Blindside", id = 328085, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
                { name = "Nightstalker", id = 14062, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Subterfuge", id = 108208, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Master Assassin", id = 255989, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
                { name = "Vigor", id = 14983, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
                { name = "Deeper Stratagem", id = 193531, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
                { name = "Marked for Death", id = 137619, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
                { name = "Leeching Poison", id = 280716, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Cheat Death", id = 31230, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Elusiveness", id = 79008, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
                { name = "Internal Bleeding", id = 154904, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
                { name = "Iron Wire", id = 196861, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
                { name = "Prey on the Weak", id = 131511, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
                { name = "Venom Rush", id = 152152, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Alacrity", id = 193539, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
                { name = "Exsanguinate", id = 200806, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
                { name = "Poison Bomb", id = 255544, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
                { name = "Hidden Blades", id = 270061, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
                { name = "Crimson Tempest", id = 121411, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
            },
        	OUTLAW = {
        		{ name = "Weaponmaster", id = 200733, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Quick Draw", id = 196938, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Ghostly Strike", id = 196937, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Acrobatic Strikes", id = 196924, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Retractable Hook", id = 256188, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Hit and Run", id = 196922, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Vigor", id = 14983, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Deeper Stratagem", id = 193531, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Marked for Death", id = 137619, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Iron Stomach", id = 193546, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Cheat Death", id = 31230, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Elusivness", id = 79008, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Dirty Tricks", id = 108216, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Blinding Powder", id = 256165, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Prey on the Weak", id = 131511, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Loaded Dice", id = 256170, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Alacrity", id = 193539, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Dreadblades", id = 343142, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Dancing Steel", id = 272026, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Blade Rush", id = 271877, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Killing Spree", id = 51690, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
            },
        	SUBTLETY = {
        		{ name = "Weaponmaster", id = 193537, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Premeditation", id = 343160, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Gloomblade", id = 200758, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Nightstalker", id = 14062, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Subterfuge", id = 108208, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Shadow Focus", id = 108209, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Vigor", id = 14983, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Deeper Stratagem", id = 193531, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Marked for Death", id = 137619, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Soothing Darkness", id = 200759, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Cheat Death", id = 31230, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Elusiveness", id = 79008, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Shot in the Dark", id = 257505, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Night Terrors", id = 277953, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Prey on the Weak", id = 131511, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Dark Shadow", id = 245687, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Alacrity", id = 193539, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Enveloping Shadows", id = 238104, requiresAura = false, requiredAuraID = nil, passive = true0, isReplacement = false, replacesSpell = nil },
        		{ name = "Master of Shadows", id = 196976, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Secret Technique", id = 280719, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Shuriken Tornado", id = 277925, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
            },
        },
        SHAMAN = {
        	ELEMENTAL = {
        		{ name = "Earthen Rage", id = 170374, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Echo of the Elements", id = 333919, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Static Discharge", id = 342243, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Aftershock", id = 273221, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Echoing Shock", id = 320125, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Elemental Blast", id = 117014, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Spirit Wolf", id = 260878, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Earth Shield", id = 974, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Static Charge", id = 265046, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Master of the Elements", id = 16166, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Storm Elemental", id = 192249, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = true, replacesSpell = 198067 },
        		{ name = "Liquid Magma Totem", id = 192222, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Nature's Guardian", id = 30884, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Ancestral Guidance", id = 108281, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Wind Rush Totem", id = 192077, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Surge of Power", id = 262303, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Primal Elementalist", id = 117013, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Icefury", id = 210714, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Unlimited Power", id = 260895, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Stormkeeper", id = 191634, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Ascendance", id = 114050, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
            },
        	ENHANCEMENT = {
        		{ name = "Lashing Flames", id = 334046, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Forceful Winds", id = 262647, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Elemental Blast", id = 117014, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Stormflurry", id = 344357, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Hot Hand", id = 201900, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Ice Strike", id = 342240, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Spirit Wolf", id = 260878, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Earth Shield", id = 974, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Static Charge", id = 265046, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Elemental Assault", id = 210853, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Hailstorm", id = 334195, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Fire Nova", id = 333974, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Nature's Guardian", id = 30884, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Feral Lunge", id = 196884, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Wind Rush Totem", id = 192077, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Crashing Storm", id = 192246, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Stormkeeper", id = 320137, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Sundering", id = 197214, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Elemental Spirits", id = 262624, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Earthen Spike", id = 188089, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Ascendance", id = 114051, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
            },
        	RESTORATION = {
        		{ name = "Torrent", id = 200072, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Undulation", id = 200071, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Unleash Life", id = 73685, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Echo of the Elements", id = 108283, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Deluge", id = 200076, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Surge of Earth", id = 320746, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Spirit Wolf", id = 260878, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Earthgrab Totem", id = 51485, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Static Charge", id = 265046, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Ancestral Vigor", id = 207401, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Earthen Wall Totem", id = 198838, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Ancestral Protection Totem", id = 207399, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Nature's Guardian", id = 30884, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Graceful Spirit", id = 192088, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Wind Rush Totem", id = 192077, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Flash Flood", id = 280614, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Downpour", id = 207778, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Cloudburst Totem", id = 157153, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = true, replacesSpell = 5394 },
        		{ name = "High Tide", id = 157154, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Wellspring", id = 197995, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Ascendance", id = 114052, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
            },
        },
        WARLOCK = {
        	AFFLICTION = {
        		{ name = "Nightfall", id = 108558, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Inevitable Demise", id = 334319, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Drain Soul", id = 198590, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = true, replacesSpell = 686 },
        		{ name = "Writhe in Agony", id = 196102, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Absolute Corruption", id = 196103, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Siphon Life", id = 63106, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Demon Skin", id = 219272, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Burning Rush", id = 111400, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Dark Pact", id = 108416, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Sow the Seeds", id = 196226, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Phantom Singularity", id = 205179, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Vile Taint", id = 278350, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Darkfury", id = 264874, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Mortal Coil", id = 6789, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Howl of Terror", id = 5484, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Dark Caller", id = 334183, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Haunt", id = 48181, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Grimoire of Sacrifice", id = 108503, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Soul Conduit", id = 215941, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Creeping Death", id = 264000, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Dark Soul: Misery", id = 113860, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
            },
        	DEMONOLOGY = {
        		{ name = "Dreadlash", id = 264078, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Bilescourge Bombers", id = 267211, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Demonic Strength", id = 267171, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Demonic Calling", id = 205145, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Power Siphon", id = 264130, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Doom", id = 603, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Demon Skin", id = 219272, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Burning Rush", id = 111400, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Dark Pact", id = 108416, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "From the Shadows", id = 267170, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Soul Strike", id = 264057, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Summon Vilefiend", id = 264119, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Darkfury", id = 264874, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Mortal Coil", id = 6789, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Howl of Terror", id = 5484, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Soul Conduit", id = 215941, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Inner Demons", id = 267216, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Grimoire: Felguard", id = 111898, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Sacrificed Souls", id = 267214, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Demonic Consumption", id = 267215, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Nether Portal", id = 267217, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
            },
        	DESTRUCTION = {
        		{ name = "Flashover", id = 267115, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Eradication", id = 196412, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Soul Fire", id = 6353, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Reverse Entropy", id = 205148, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Internal Combustion", id = 266134, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Shadowburn", id = 17877, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Demon Skin", id = 219272, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Burning Rush", id = 111400, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Dark Pact", id = 108416, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Inferno", id = 270545, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Fire and Brimstone", id = 196408, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Cataclysm", id = 152108, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Darkfury", id = 264874, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Mortal Coil", id = 6789, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Howl of Terror", id = 5484, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Roaring Blaze", id = 205184, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Rain of Chaos", id = 266086, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Grimoire of Sacrifice", id = 108503, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Soul Conduit", id = 215941, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Channel Demonfire", id = 196447, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Dark Soul: Instability", id = 113858, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
            },
        },
        WARRIOR = {
        	ARMS = {
        		{ name = "War Machine", id = 262231, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Sudden Death", id = 29725, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Skullsplitter", id = 260643, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Double Time", id = 103827, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Impending Victory", id = 202168, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = true, replacesSpell = 34428 },
        		{ name = "Storm Bolt", id = 107570, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Massacre", id = 281001, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Fervor of Battle", id = 202316, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Rend", id = 772, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Second Wind", id = 29838, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Bounding Stride", id = 202163, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Defensive Stance", id = 197690, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Collateral Damage", id = 334779, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Warbreaker", id = 262161, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = true, replacesSpell = 167105 },
        		{ name = "Cleave", id = 845, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "In For The Kill", id = 248621, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Avatar", id = 107574, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Deadly Calm", id = 262228, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Anger Management", id = 152278, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Dreadnaught", id = 262150, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Ravager", id = 152277, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
            },
        	FURY = {
        		{ name = "War Machine", id = 346002, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Sudden Death", id = 280721, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Fresh Meat", id = 215568, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Double Time", id = 103827, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Impending Victory", id = 202168, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = true, replacesSpell = 34428 },
                { name = "Storm Bolt", id = 107570, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Massacre", id = 206315, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Frenzy", id = 335077, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Onslaught", id = 315720, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Furious Charge", id = 202224, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Bounding String", id = 202163, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Warpaint", id = 208154, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Seethe", id = 335091, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Frothing Berserker", id = 215571, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Cruelty", id = 335070, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Meat Cleaver", id = 280392, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Dragon Roar", id = 118000, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Bladestorm", id = 46924, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Anger Management", id = 152278, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Reckless Abandon", id = 202751, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Siegebreaker", id = 280772, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
            },
        	PROTECTION = {
        		{ name = "War Machine", id = 316733, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Punish", id = 275334, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Devastator", id = 236279, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = true, replacesSpell = 20243 },
        		{ name = "Double Time", id = 103827, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Rumbling Earth", id = 275339, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Storm Bold", id = 107570, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Best Served Cold", id = 202560, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Booming Voice", id = 202743, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Dragon Roar", id = 118000, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Crackling Thunder", id = 203201, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Bounding Strike", id = 202163, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Menace", id = 275338, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Never Surrender", id = 202561, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Indomitable", id = 202095, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Impending Victory", id = 202168, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = true, replacesSpell = 34428  },
        		{ name = "Into the Fray", id = 202603, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Unstoppable Force", id = 275336, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Ravager", id = 228920, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Anger Management", id = 152278, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Heavy Repercussions", id = 203177, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Bolster", id = 280001, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
            },
        }
    }
    
    self.pvp_talents = {
        DEATHKNIGHT = {
        	BLOOD = {
        		{ name = "Blood for Blood", id = 233411, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Dark Simulacrum", id = 77606, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Death Chain", id = 203173, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Decomposing Aura", id = 199720, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Dome of Ancient Shadow", id = 328718, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Last Dance", id = 233412, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Murderous Intent", id = 207018, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = true, replacesSpell = 56222 },
        		{ name = "Necrotic Aura", id = 199642, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Rot and Wither", id = 202727, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Strangulate", id = 47476, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Walking Dead", id = 202731, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        	},
        	FROST = {
        		{ name = "Cadaverous Pallor", id = 201995, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Chill Streak", id = 305392, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Dark Simulacrum", id = 77606, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Dead of Winter", id = 287250, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Deathchill", id = 204080, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Delirium", id = 233396, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Dome of Ancient Shadow", id = 328718, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Heartstop Aura", id = 199719, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Necrotic Aura", id = 199642, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Transfusion", id = 288977, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        	},
        	UNHOLY = {
        		{ name = "Cadaverous Pallor", id = 201995, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Dark Simulacrum", id = 77606, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Decomposing Aura", id = 199720, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Dome of Ancient Shadow", id = 328718, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Life and Death", id = 288855, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Necromancer's Bargain", id = 288848, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Necrotic Aura", id = 199642, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Necrotic Strike", id = 223829, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Raise Abomination", id = 288853, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = true, replacesSpell = 42650 },
        		{ name = "Reanimation", id = 210128, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Transfusion", id = 288977, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        	},
        },
        DEMONHUNTER = {
        	HAVOC = {
        		{ name = "Cleansed by Flame", id = 205625, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Cover of Darkness", id = 227635, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Demonic Origins", id = 235893, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Detainment", id = 205596, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Eye of Leotheras", id = 206649, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Mana Break", id = 203704, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Mana Rift", id = 235903, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Mortal Rush", id = 328725, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Rain from Above", id = 206803, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Reverse Magic", id = 205604, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Unending Hatred", id = 213480, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        	},
        	VENGEANCE = {
        		{ name = "Cleansed by Flame", id = 205625, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Demonic Trample", id = 205629, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Detainment", id = 205596, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Everlasting Hunt", id = 205626, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Illidan's Grasp", id = 205630, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Jagged Spikes", id = 205627, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Reverse Magic", id = 205604, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Sigil Mastery", id = 211489, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Tormentor", id = 207029, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = true, replacesSpell = 185245 },
        		{ name = "Unending Hatred", id = 213480, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        	},
        },
        DRUID = {
        	BALANCE = {
        		{ name = "Celestial Guardian", id = 233754, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Crescent Burn", id = 200567, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Deep Roots", id = 233755, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Dying Stars", id = 232546, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Faerie Swarm", id = 209749, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "High Winds", id = 200931, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Moon and Stars", id = 233750, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Moonkin Aura", id = 209740, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Prickling Thorns", id = 200549, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Protector of the Grove", id = 209730, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Thorns", id = 305497, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        	},
        	FERAL = {
        		{ name = "Ferocious Wound", id = 236020, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Freedom of the Herd", id = 213200, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Fresh Wound", id = 203224, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "High Winds", id = 200931, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "King of the Jungle", id = 203052, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Leader of the Pack", id = 202626, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Malorne's Swiftness", id = 236012, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Rip and Tear", id = 203242, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Savage Momentum", id = 205673, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Strength of the Wild", id = 236019, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Thorns", id = 305497, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        	},
        	GUARDIAN = {
        		{ name = "Alpha Challenge", id = 207017, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = true, replacesSpell = 6795 },
        		{ name = "Charging Bash", id = 228431, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Demoralizing Roar", id = 201664, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Den Mother", id = 236180, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Entangling Claws", id = 202226, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Freedom of the Herd", id = 213200, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "High Winds", id = 200931, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Malorne's Swiftness", id = 236147, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Master Shapeshifter", id = 236144, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Overrun", id = 202246, requiresAura = true, requiredAuraID = {5487}, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Raging Frenzy", id = 236153, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Roar of the Protector", id = 329042, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Sharpened Claws", id = 202110, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Toughness", id = 201259, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        	},
        	RESTORATION = {
        		{ name = "Deep Roots", id = 233755, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Disentanglement", id = 233673, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Early Spring", id = 203624, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Entangling Bark", id = 247543, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Focused Growth", id = 203553, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "High Winds", id = 200931, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Mark of the Wild", id = 289318, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Master Shapeshifter", id = 289237, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Reactive Resin", id = 203399, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Thorns", id = 305497, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
            },
        },
        HUNTER = {
        	BEASTMASTERY = {
        		{ name = "Dire Beast: Basilisk", id = 205691, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Dire Beast: Hawk", id = 208652, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Dragonscale Armor", id = 202589, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Hi-Explosive Trap", id = 236776, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Hunting Pack", id = 203235, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Interlope", id = 248518, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Roar of Sacrifice", id = 53480, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Scorpid Sting", id = 202900, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Spider Sting", id = 202914, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Survival Tactics", id = 202746, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "The Beast Within", id = 212668, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Viper Sting", id = 202797, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Wild Protector", id = 204190, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        	},
        	MARKSMANSHIP = {
        		{ name = "Dragonscale Armor", id = 202589, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Hi-Explosive Trap", id = 236776, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Hunting Pack", id = 203235, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Ranger's Finesse", id = 248443, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Roar of Sacrifice", id = 53480, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Scatter Shot", id = 213691, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Scorpid Sting", id = 202900, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Sniper Shot", id = 203155, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Spider Sting", id = 202914, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Survival Tactics", id = 202746, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Trueshot Mastery", id = 203129, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Viper Sting", id = 202797, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil},
        	},
        	SURVIVAL = {
        		{ name = "Diamond Ice", id = 203340, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Dragonscale Armor", id = 202589, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Hi-Explosive Trap", id = 236776, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Hunting Pack", id = 203235, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Mending Bandage", id = 212640, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Roar of Sacrifice", id = 53480, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Scorpid Sting", id = 202900, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Spider Sting", id = 202914, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Sticky Tar", id = 203264, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Survival Tactics", id = 202746, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Tracker's Net", id = 212638, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Viper Sting", id = 202797, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        	},
        },
        MAGE = {
        	ARCANE = {
        		{ name = "Arcane Empowerment", id = 276741, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Dampened Magic", id = 236788, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Kleptomania", id = 198100, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Mass Invisibility", id = 198158, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Master of Escape", id = 210476, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Netherwind Armor", id = 198062, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Prismatic Cloak", id = 198064, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Temporal Shield", id = 198111, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Torment the Weak", id = 198151, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        	},
        	FIRE = {
        		{ name = "Controlled Burn", id = 280450, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Dampened Magic", id = 236788, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Flamecannon", id = 203284, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Greater Pyroblast", id = 203286, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Kleptomania", id = 198100, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Netherwind Armor", id = 198062, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Prismatic Cloak", id = 198064, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Pyrokinesis", id = 203283, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Tinder", id = 203275, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "World in Flames", id = 203280, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        	},
        	FROST = {
        		{ name = "Burst of Cold", id = 206431, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Chilled to the Bone", id = 198126, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Concentrated Coolness", id = 198148, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Dampened Magic", id = 236788, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Deep Shatter", id = 198123, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Frostbite", id = 198120, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Ice Form", id = 198144, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = true, replacesSpell = 12472 },
        		{ name = "Kleptomania", id = 198100, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Netherwind Armor", id = 198062, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Prismatic Cloak", id = 198064, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        	},
        },
        MONK = {
        	BREWMASTER = {
        		{ name = "Admonishment", id = 207025, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = true, replacesSpell = 115546 },
        		{ name = "Avert Harm", id = 202162, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Craft: Nimble Brew", id = 213658, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Double Barrel", id = 202335, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Eerie Fermentation", id = 205147, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Guided Meditation", id = 202200, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Hot Trub", id = 202126, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Incendiary Breath", id = 202272, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Microbrew", id = 202107, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Mighty Ox Kick", id = 202370, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Niuzao's Essence", id = 232876, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        	},
        	MISTWEAVER = {
        		{ name = "Chrysalis", id = 202424, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Counteract Magic", id = 202428, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Dome of Mist", id = 202577, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Eminence", id = 216255, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Grapple Weapon", id = 233759, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Healing Sphere", id = 205234, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Refreshing Breeze", id = 202523, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Surging Mist", id = 227344, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Zen Focus Tea", id = 209584, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        	},
        	WINDWALKER = {
        		{ name = "Alpha Tiger", id = 287503, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Disabling Reach", id = 201769, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Grapple Weapon", id = 233759, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Pressure Points", id = 345829, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Reverse Harm", id = 342928, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Ride the Wind", id = 201372, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Tigereye Brew", id = 247483, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Turbo Fists", id = 287681, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Wind Waker", id = 287506, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        	},
        },
        PALADIN = {
        	HOLY = {
        		{ name = "Avenging Light", id = 199441, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Blessed Hands", id = 199454, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Cleanse the Weak", id = 199330, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Darkest before the Dawn", id = 210378, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Divine Favor", id = 210294, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Divine Vision", id = 199324, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Hallowed Ground", id = 216868, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Light's Grace", id = 216327, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Spear Hand Strike", id = 116705, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Spreading the Word", id = 199456, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Ultimate Sacrifice", id = 199452, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        	},
        	PROTECTION = {
        		{ name = "Cleansing Light", id = 236186, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = true, replacesSpell = 213644 },
        		{ name = "Guarded by the Light", id = 216855, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Guardian of the Forgotten Queen", id = 228049, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = true, replacesSpell = 86659 },
        		{ name = "Hallowed Ground", id = 216868, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Inquisition", id = 207028, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = true, replacesSpell = 62124 },
        		{ name = "Judgments of the Pure", id = 216860, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Luminescence", id = 199428, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Sacred Duty", id = 216853, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Shield of Virtue", id = 215652, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Steed of Glory", id = 199542, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Unbound Freedom", id = 305394, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Warrior of Light", id = 210341, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        	},
        	RETRIBUTION = {
        		{ name = "Aura of Reckoning", id = 247675, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Blessing of Sanctuary", id = 210256, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Cleansing Light", id = 236186, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = true, replacesSpell = 213644 },
        		{ name = "Divine Punisher", id = 204914, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Jurisdiction", id = 204979, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Law and Order", id = 204934, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Lawbringer", id = 246806, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Luminescence", id = 199428, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Ultimate Retribution", id = 287947, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Unbound Freedom", id = 305394, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Vengeance Aura", id = 210323, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
            },
        },
        PRIEST = {
        	DISCIPLINE = {
        		{ name = "Archangel", id = 197862, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Dark Archangel", id = 197871, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Dome of Light", id = 197590, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Purification", id = 196162, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Purified Resolve", id = 196439, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Searing Light", id = 215768, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Strength of Soul", id = 197535, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Thoughtsteal", id = 316262, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Trinity", id = 214205, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Ultimate Radiance", id = 236499, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        	},
        	HOLY = {
        		{ name = "Cardinal Mending", id = 328529, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Delivered from Evil", id = 196611, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Divine Ascension", id = 328530, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Greater Fade", id = 213602, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = true, replacesSpell = 586 },
        		{ name = "Greater Heal", id = 289666, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Holy Ward", id = 213610, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Holy Word: Concentration", id = 289657, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Miracle Worker", id = 235587, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Ray of Hope", id = 197268, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Spirit of the Redeemer", id = 215982, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = true, replacesSpell = 20711 },
        		{ name = "Thoughtsteal", id = 316262, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        	},
        	SHADOW = {
        		{ name = "Driven to Madness", id = 199259, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Greater Fade", id = 213602, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = true, replacesSpell = 586 },
        		{ name = "Lasting Plague", id = 341167, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Mind Trauma", id = 199445, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Psyfiend", id = 211522, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Thoughtsteal", id = 316262, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Void Origins", id = 228630, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Void Shield", id = 280749, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Void Shift", id = 108968, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        	},
        },
        ROGUE = {
        	ASSASSINATION = {
        		{ name = "Creeping Venom", id = 198092, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Death from Above", id = 269513, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Flying Daggers", id = 198128, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Honor Among Thieves", id = 198032, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Intent to Kill", id = 197007, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Maneuverability", id = 197000, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Mind-Numbing Poison", id = 197050, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Neurotoxin", id = 206328, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Smoke Bomb", id = 212182, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "System Shock", id = 198145, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        	},
        	OUTLAW = {
        		{ name = "Boarding Party", id = 209752, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Cheap Tricks", id = 212035, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Control is King", id = 212217, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Death From Above", id = 269513, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Dismantle", id = 207777, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Drink Up Me Hearties", id = 212210, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Honor Among Thieves", id = 198032, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Maneuverability", id = 197000, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Plunder Armor", id = 198529, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Smonke Bomb", id = 212182, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Take Your Cut", id = 198265, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Thick as Thieves", id = 221622, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Turn the Tables", id = 198020, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        	},
        	SUBTLETY = {
        		{ name = "Cold Blood", id = 213981, requiresAura = true, requiredAuraID = {1784}, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Dagger in the Dark", id = 198675, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Death from Above", id = 269513, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Honor Among Thieves", id = 198032, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Maneuverability", id = 197000, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Shadowy Duel", id = 207736, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Silhouette", id = 197899, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Smoke Bomb", id = 212182, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Thief's Bargain", id = 212081, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Veil of Midnight", id = 198952, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        	},
        },
        SHAMAN = {
        	ELEMENTAL = {
        		{ name = "Control of Lava", id = 204393, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = true, replacesSpell = 77756 },
        		{ name = "Counterstrike Totem", id = 204331, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Elemental Attunement", id = 204385, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Grounding Totem", id = 204336, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Lightning Lasso", id = 305483, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Purifying Waters", id = 204247, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Skyfury Totem", id = 204330, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Spectral Recovery", id = 204261, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Swelling Waves", id = 204264, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Traveling Storms", id = 204403, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        	},
        	ENHANCEMENT = {
        		{ name = "Counterstrike Totem", id = 204331, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Ethereal Form", id = 210918, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = true, replacesSpell = 108271 },
        		{ name = "Grounding Totem", id = 204336, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Purifying Waters", id = 204247, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Ride the Lightning", id = 289874, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Shamanism", id = 193876, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Skyfury Totem", id = 204330, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Spectral Recovery", id = 204261, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Swelling Waves", id = 204264, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Thundercharge", id = 204366, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        	},
        	RESTORATION = {
        		{ name = "Ancestral Gift", id = 290254, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Cleansing Waters", id = 290250, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Counterstrike Totem", id = 204331, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Electrocute", id = 206642, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Grounding Totem", id = 204336, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Skyfury Totem", id = 204330, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Spectral Recovery", id = 204261, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Spirit Link", id = 204293, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = true, replacesSpell = 98008 },
        		{ name = "Swelling Waves", id = 204264, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Tidebringer", id = 236501, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Voodoo Mastery", id = 204268, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        	},
        },
        WARLOCK = {
        	AFFLICTION = {
        		{ name = "Amplify Curse", id = 328774, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Bane of Fragility", id = 199954, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Bane of Shadows", id = 234877, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Casting Circle", id = 221703, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Deathbolt", id = 264106, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Demon Armor", id = 285933, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Essence Drain", id = 221711, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Gateway Mastery", id = 248855, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Nether Ward", id = 212295, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Rampant Afflictions", id = 335052, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Rapid Contagion", id = 344566, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Rot and Decay", id = 212371, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Soulshatter", id = 212356, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        	},
        	DEMONOLOGY = {
        		{ name = "Amplify Curse", id = 328774, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Bane of Fragility", id = 199954, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Call Fel Lord", id = 212459, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Call Felhunter", id = 212619, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Call Observer", id = 201996, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Casting Circle", id = 221703, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Essence Drain", id = 221711, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Gateway Mastery", id = 248855, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Master Summoner", id = 212628, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Nether Ward", id = 212295, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Pleasure through Pain", id = 212618, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Singe Magic", id = 212623, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        	},
        	DESTRUCTION = {
        		{ name = "Amplify Curse", id = 328774, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Bane of Fragility", id = 199954, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Bane of Havoc", id = 200546, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = true, replacesSpell = 80240 },
        		{ name = "Casting Circle", id = 221703, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Cremation", id = 212282, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Demon Armor", id = 285933, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Essence Drain", id = 221711, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Fel Fissure", id = 200586, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Focused Chaos", id = 233577, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Gateway Mastery", id = 248855, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Nether Ward", id = 212295, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        	},
        },
        WARRIOR = {
        	ARMS = {
        		{ name = "Death Sentence", id = 198500, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Demolition", id = 329033, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Disarm", id = 236077, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Duel", id = 236273, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Master and Commander", id = 235941, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Overwatch", id = 329035, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Shadow of the Colossus", id = 198807, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Sharpen Blade", id = 198817, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Storm of Destruction", id = 236308, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "War Banner", id = 236320, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        	},
        	FURY = {
        		{ name = "Barbarian", id = 280745, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Battle Trance", id = 213857, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Bloodrage", id = 329038, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Death Senctence", id = 198500, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Death Wish", id = 199261, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Demolition", id = 329033, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Disarm", id = 236077, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Enduring Rage", id = 198877, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Master and Commander", id = 235941, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Overwatch", id = 329035, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Slaughterhouse", id = 280747, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        	},
        	PROTECTION = {
        		{ name = "Bodyguard", id = 213871, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Demolition", id = 329033, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Disarm", id = 236077, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Dragon Charge", id = 206572, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Morale Killer", id = 199023, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Oppressor", id = 205800, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = true, replacesSpell = 355 },
        		{ name = "Overwatch", id = 329035, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Rebound", id = 213915, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Shield Bash", id = 198912, requiresAura = false, requiredAuraID = nil, passive = false, isReplacement = false, replacesSpell = nil },
        		{ name = "Sword and Board", id = 199127, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Thunderstruck", id = 199045, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        		{ name = "Warpath", id = 199086, requiresAura = false, requiredAuraID = nil, passive = true, isReplacement = false, replacesSpell = nil },
        	},
        }
    }    
    return self
end

-- returns a table with all spells for a certain class and spec
-- @param _class the identifier for the class
-- @param _sepc the identifier for the specilization
-- @param _includeBasic boolean indicates if the basic class spells will be returned aswell
-- @param _includeCovenant boolean indicates if the covenant class spells will be returned aswell
function SpellLib:GetClassSpecSpells(_class, _spec, _includeBasic, _includeCovenant)
    _spec = _spec or "ALL"
    _includeBasic = _includeBasic or true
    _includeCovenant = _includeCovenant or true
    
    local getSpells = {}                                                                               
    if _class == nil or _class == "" then
        print(self.errorText .. 'Error in SpellLib:GetClassCovenantSpells() first parameter (_class) is undefined.')
        return nil
    elseif self:tContains(self.classNames, _class) ~= 1 then
        print(self.errorText .. 'Error in SpellLib:GetClassCovenantSpells() first parameter (_class) set to an illegal value.')
        return nil
    elseif _class == "ALL" then
        return self.classSpells[_class][_spec]
    elseif _spec == nil or _spec == "" then 
        print(self.errorText .. 'Error in SpellLib:GetClassSpecSpells() second parameter (_spec) is undefined.')
        return nil         
    elseif self:tContains(self.specNames, _spec) ~= 1 then
        print(self.errorText .. 'Error in SpellLib:GetClassCovenantSpells() second parameter (_spec) set to an illegal value.')
        return nil
    else        
        if _spec == "ALL" then
            return self.classSpells[_class]
        else
            getSpells[_spec] = self.classSpells[_class][_spec]
            if _includeBasic == true then
                getSpells['BASIC'] = {}
                for i,v in pairs(self.classSpells[_class]['BASIC']) do
                    tinsert(getSpells['BASIC'], v)
                end                 
            end            
            if _includeCovenant == true then 
                getSpells['COVENANT'] = {}
                for i,v in pairs(self.classSpells[_class]['COVENANT']) do
                    tinsert(getSpells['COVENANT'], v)
                end                            
            end
        end     
    end
    return getSpells                    
end

-- returns a table with all general COVENANT abilities
function SpellLib:GetGeneralCovenantSpells()
    local getSpells = self.classSpells['COVENANT']['GENERAL']
    return getSpells
end

-- returns a table with all COVENANT abilites for a certain class
-- @param _class Class identifier
function SpellLib:GetClassCovenantSpells(_class)
    if _class == nil or _class == "" then
        print(self.errorText .. 'Error in SpellLib:GetClassCovenantSpells() first parameter (_class) is undefined.')
        return nil
    elseif self:tContains(self.classNames, _class) ~= 1 then
        print(self.errorText .. 'Error in SpellLib:GetClassCovenantSpells() first parameter (_class) set to an illegal value.')
        return nil
    end
    
    return self.classSpells[_class]['COVENANT']
end

-- returns a table with all talents for a certain class spec
function SpellLib:GetSpecTalents(_class, _spec)
    if _class == nil or _class == "" then
        print(self.errorText .. 'Error in SpellLib:GetSpecTalents() first parameter (_class) is undefined.')
        return nil
    elseif self:tContains(self.classNames, _class) ~= 1 then
        print(self.errorText .. 'Error in SpellLib:GetSpecTalents() first parameter (_class) set to an illegal value.')
        return nil
    elseif _spec == nil or _spec == "" then 
        print(self.errorText .. 'Error in SpellLib:GetSpecTalents() second parameter (_spec) is undefined.')
        return nil         
    elseif self:tContains(self.specNames, _spec) ~= 1 then
        print(self.errorText .. 'Error in SpellLib:GetSpecTalents() second parameter (_spec) set to an illegal value.')
        return nil
    end
    
    return self.talents[_class][_spec]
end

-- returns a table with all pvp talents for a certain class spec
function SpellLib:GetSpecPVPTalents(_class, _spec)
    if _class == nil or _class == "" then
        print(self.errorText .. 'Error in SpellLib:GetSpecPVPTalents() first parameter (_class) is undefined.')
        return nil
    elseif self:tContains(self.classNames, _class) ~= 1 then
        print(self.errorText .. 'Error in SpellLib:GetSpecPVPTalents() first parameter (_class) set to an illegal value.')
        return nil
    elseif _spec == nil or _spec == "" then 
        print(self.errorText .. 'Error in SpellLib:GetSpecPVPTalents() second parameter (_spec) is undefined.')
        return nil         
    elseif self:tContains(self.specNames, _spec) ~= 1 then
        print(self.errorText .. 'Error in SpellLib:GetSpecPVPTalents() second parameter (_spec) set to an illegal value.')
        return nil
    end
    
    return self.pvp_talents[_class][_spec]
end

-- checks if a table contains a certain item
-- @param _table the table to search
-- @param _item the item  value
function SpellLib:tContains(_table, _item)
    local index = 1;
    while _table[index] do
        if ( _item == _table[index] ) then        
            return 1;
        end
        index = index + 1;
    end
    return nil;
end